import math
import tkinter as tk
import tkinter.ttk as tkk
from random import uniform
from tkinter import ttk

import sympy as sp
from io import BytesIO
from PIL import Image, ImageTk
from sympy import *
from numpy import *
import funcs
import plot_funcs
from numpy.linalg import norm
import numpy as np
#### FUNCS
def convert_to_mat(expr_):
    expr_with_underscore_ = expr_
    if len(expr_) > 1:
        list_index_digits = []
        l_num = []
        expr_without_underscores_ = ""
        for compt_i_ in range(0, len(expr_)):
            if expr_[compt_i_] not in ["_", "{"]:
                expr_without_underscores_ = expr_without_underscores_ + expr_[compt_i_]
        expr_with_underscore_ = expr_without_underscores_
        for compt_i_ in range(0, len(expr_without_underscores_)):
            if expr_without_underscores_[compt_i_].isdigit():
                l_num.append(compt_i_)
            else:
                if len(l_num):
                    list_index_digits.append(l_num)
                l_num = []
        if len(l_num):
            list_index_digits.append(l_num)
        decla_ = 0
        for compt_i_ in range(0, len(list_index_digits)):
            expr_with_underscore_ = expr_with_underscore_[:list_index_digits[compt_i_][0]+decla_] + "_{" + expr_with_underscore_[list_index_digits[compt_i_][0]+decla_:]
            decla_ += 2
            expr_with_underscore_ = expr_with_underscore_[:list_index_digits[compt_i_][-1]+1+decla_] + "}" + expr_with_underscore_[list_index_digits[compt_i_][-1]+1+decla_:]
            decla_ += 1
        # print("expr_without_underscores=", expr_without_underscores_)
        # print("list_index_digits=", list_index_digits)
        # print("expr_with_backslash_=", expr_with_underscore_)
    if expr_[0] != "\\":
        expr_with_backslash_ = "\\" + expr_with_underscore_
    else:
        expr_with_backslash_ = expr_with_underscore_
        expr_with_underscore_ = expr_with_underscore_[1:]
    # print("expr_with_backslash_=", expr_with_backslash_)
    format_latex = r'${0}$'.format(expr_with_backslash_)
    f_ = BytesIO()
    try:
        sp.preview(format_latex, viewer='BytesIO', outputbuffer=f_)
    except RuntimeError:
        return expr_with_underscore_
    else:
        return expr_with_backslash_

def add_dot_to_state(state_):
    return r'\dot{{ {0} }}'.format(state_)

def get_images_of_state_eq(state_):
    list_states_imgs_ = []
    for i_state in range(0, len(state_)):
        state_i_mat = convert_to_mat(state_[i_state][0])
        state_i_with_backslash = add_dot_to_state(state_i_mat)
        # print("state_i_with_backslash=", state_i_with_backslash)
        state_i_with_equation = '$' + state_i_with_backslash + r' = {0}$'.format(state_[i_state][4])
        # print("state_i_with_equation=", state_i_with_equation)
        f_ = BytesIO()
        sp.preview(state_i_with_equation, viewer='BytesIO', outputbuffer=f_, euler=False, dvioptions=['-D', '250'])
        f_.seek(0)
        img_ = Image.open(f_)
        pimg_ = ImageTk.PhotoImage(img_)
        list_states_imgs_.append(pimg_)
    return list_states_imgs_

def get_images_of_state_name(state_):
    list_states_imgs_ = []
    list_state_i_mat = []
    for i_state in range(0, len(state_)):
        state_i_mat = convert_to_mat(state_[i_state][0])
        # print("state_i_with_backslash=", state_i_with_backslash)
        state_i_with_equation = '$' + state_i_mat + r'$'
        # print("state_i_with_equation=", state_i_with_equation)
        f_ = BytesIO()
        sp.preview(state_i_with_equation, viewer='BytesIO', outputbuffer=f_, euler=False, dvioptions=['-D', '250'])
        f_.seek(0)
        img_ = Image.open(f_)
        pimg_ = ImageTk.PhotoImage(img_)
        list_states_imgs_.append(pimg_)
        list_state_i_mat.append(state_i_mat)
    return list_states_imgs_, list_state_i_mat

def get_images_of_state_name_point(state_):
    list_states_imgs_ = []
    for i_state in range(0, len(state_)):
        state_i_mat = convert_to_mat(state_[i_state][0])
        state_i_with_backslash = add_dot_to_state(state_i_mat)
        # print("state_i_with_backslash=", state_i_with_backslash)
        state_i_with_equation = '$' + state_i_with_backslash + r'$'
        # print("state_i_with_equation=", state_i_with_equation)
        f_ = BytesIO()
        sp.preview(state_i_with_equation, viewer='BytesIO', outputbuffer=f_, euler=False, dvioptions=['-D', '250'])
        f_.seek(0)
        img_ = Image.open(f_)
        pimg_ = ImageTk.PhotoImage(img_)
        list_states_imgs_.append(pimg_)
    return list_states_imgs_

def get_images_of_parameter_eq(parameter_):
    list_parameters_imgs_ = []
    for i_parameter in range(0, len(parameter_)):
        parameter_i_mat = convert_to_mat(parameter_[i_parameter][0])
        # print("parameter_i_with_backslash=", parameter_i_with_backslash)
        parameter_i_with_equation = '$' + parameter_i_mat + r' = {0}$'.format(parameter_[i_parameter][4])
        # print("parameter_i_with_equation=", parameter_i_with_equation)
        f_ = BytesIO()
        sp.preview(parameter_i_with_equation, viewer='BytesIO', outputbuffer=f_, euler=False, dvioptions=['-D', '250'])
        f_.seek(0)
        img_ = Image.open(f_)
        pimg_ = ImageTk.PhotoImage(img_)
        list_parameters_imgs_.append(pimg_)
    return list_parameters_imgs_


def get_images_of_matrix_eq(matrix_):
    list_matrices_imgs_ = []
    for i_matrix in range(0, len(matrix_)):
        matrix_i_mat = convert_to_mat(matrix_[i_matrix][0])
        # print("matrix_i_with_backslash=", matrix_i_with_backslash)
        matrix_i_with_equation = '$' + matrix_i_mat + r' = {0}$'.format(matrix_[i_matrix][4])
        # print("matrix_i_with_equation=", matrix_i_with_equation)
        f_ = BytesIO()
        sp.preview(matrix_i_with_equation, viewer='BytesIO', outputbuffer=f_, euler=False, dvioptions=['-D', '250'])
        f_.seek(0)
        img_ = Image.open(f_)
        pimg_ = ImageTk.PhotoImage(img_)
        list_matrices_imgs_.append(pimg_)
    return list_matrices_imgs_


def get_images_of_parameter_name(parameter_):
    list_parameters_imgs_ = []
    list_parameter_mat = []
    for i_parameter in range(0, len(parameter_)):
        parameter_i_mat = convert_to_mat(parameter_[i_parameter][0])
        # print("parameter_i_with_backslash=", parameter_i_with_backslash)
        parameter_i_with_equation = '$' + parameter_i_mat + r'$'
        # print("parameter_i_with_equation=", parameter_i_with_equation)
        f_ = BytesIO()
        sp.preview(parameter_i_with_equation, viewer='BytesIO', outputbuffer=f_, euler=False, dvioptions=['-D', '250'])
        f_.seek(0)
        img_ = Image.open(f_)
        pimg_ = ImageTk.PhotoImage(img_)
        list_parameters_imgs_.append(pimg_)
        list_parameter_mat.append(parameter_i_mat)
    return list_parameters_imgs_, list_parameter_mat


def get_images_of_matrix_name(matrix_):
    list_matrices_imgs_ = []
    list_matrix_mat = []
    for i_matrix in range(0, len(matrix_)):
        matrix_i_mat = convert_to_mat(matrix_[i_matrix][0])
        # print("matrix_i_with_backslash=", matrix_i_with_backslash)
        matrix_i_with_equation = '$' + matrix_i_mat + r'$'
        # print("matrix_i_with_equation=", matrix_i_with_equation)
        f_ = BytesIO()
        sp.preview(matrix_i_with_equation, viewer='BytesIO', outputbuffer=f_, euler=False, dvioptions=['-D', '250'])
        f_.seek(0)
        img_ = Image.open(f_)
        pimg_ = ImageTk.PhotoImage(img_)
        list_matrices_imgs_.append(pimg_)
        list_matrix_mat.append(matrix_i_mat)
    return list_matrices_imgs_, list_matrix_mat

def get_images_of_control_name(control_):
    list_controls_imgs_ = []
    list_control_mat = []
    for i_control in range(0, len(control_)):
        control_i_mat = convert_to_mat(control_[i_control][0])
        # print("control_i_with_backslash=", control_i_with_backslash)
        control_i_with_equation = '$' + control_i_mat + r'$'
        # print("control_i_with_equation=", control_i_with_equation)
        f_ = BytesIO()
        sp.preview(control_i_with_equation, viewer='BytesIO', outputbuffer=f_, euler=False, dvioptions=['-D', '250'])
        f_.seek(0)
        img_ = Image.open(f_)
        pimg_ = ImageTk.PhotoImage(img_)
        list_controls_imgs_.append(pimg_)
        list_control_mat.append(control_i_mat)
    return list_controls_imgs_, list_control_mat

#### COMMANDS
def new_file():
    pass

def open_file():
    pass

def save_file():
    pass

def save_as_file():
    pass

def exit_file():
    pass

def new_state():
    global state
    state.append([state_name_entry.get(), "", 0, "", ""])
    # my_label2 = tk.Label(main_window, text=state_name_entry.get(), fg="blue", bg="gray", font=("Helvtica", 32))
    # my_label2.pack()
    # state_name_entry.delete(0, tk.END)
    # state_name_entry.insert(0, "")
    print(state)

def edit_state(ind_):
    global state
    # state[ind_][0] = state_name_edit_entry.get()
    state[ind_][1] = state_expr_edit_entry.get()

def delete_state():
    global delete_state_window
    delete_state_window = tk.Toplevel()
    delete_state_window.title("Delete state")
    delete_state_window.geometry("300x400")

    global delete_states_frame
    delete_states_frame = tk.Frame(delete_state_window, borderwidth=1, bd=1, relief=tk.SUNKEN)
    states_list_label = tk.Label(delete_states_frame, text="States:", font=("Helvtica", 24))
    global list_states_delete_labels
    list_states_delete_labels = []
    for i_states_name_ in range(0, len(list_states_imgs)):
        list_states_delete_labels.append(tk.Label(delete_states_frame, image=list_states_name_point_imgs[i_states_name_]))

    list_states_delete_button = []
    for i_states_name_ in range(0, len(list_states_imgs)):
        print("i_states_name_=", i_states_name_)
        list_states_delete_button.append(
            tk.Button(delete_states_frame, text='Delete', image=delete_icon, compound=tk.LEFT,
                      command=lambda i_states1=i_states_name_: delete_state_submit(i_states1)))
    states_list_label.grid(row=0, column=0)

    for i_states_name_ in range(0, len(list_states_delete_labels)):
        list_states_delete_labels[i_states_name_].grid(row=i_states_name_ + 1, column=0, sticky="W", pady=10)
        list_states_delete_button[i_states_name_].grid(row=i_states_name_ + 1, column=1, sticky="W", padx=30, pady=10)
    delete_states_frame.grid(row=0, column=0, padx=20, pady=20, sticky="W")
    delete_state_window.mainloop()

def delete_state_submit(ind_):
    state.pop(ind_)
    list_states_name_imgs.pop(ind_)
    list_states_imgs.pop(ind_)
    list_states_name_point_imgs.pop(ind_)
    list_states_labels.pop(ind_)
    list_states_edit_button.pop(ind_)
    states_frame.grid_forget()
    states_list_label.grid(row=0, column=0)
    for label1 in states_frame.grid_slaves():
        if int(label1.grid_info()["row"]) > 0:
            label1.grid_forget()
    for i_states in range(0, len(list_states_labels)):
        # list_states_labels[i_states].destroy()
        # list_states_edit_button[i_states].grid_forget()
        list_states_edit_button[i_states] = tk.Button(states_frame, text='Edit', image=edit_icon, compound=tk.LEFT, command=lambda i_states1=i_states: open_edit_state_window(i_states1))
        list_states_labels[i_states].grid(row=i_states + 1, column=0, sticky="W", pady=10)
        list_states_edit_button[i_states].grid(row=i_states + 1, column=1, sticky="W", padx=30, pady=10)
    new_state_button.grid(row=len(list_states_labels) + 1, column=0, pady=30)
    new_guard_reset_button.grid(row=len(list_states_labels) + 2, column=0, pady=10)
    states_frame.grid(row=0, column=0, padx=20, pady=20, sticky="W")
    delete_state_window.withdraw()

def new_parameter():
    global parameter
    parameter.append([parameter_name_entry.get(), parameter_expr_edit_entry.get(), 0, "", ""])
    # my_label2 = tk.Label(main_window, text=state_name_entry.get(), fg="blue", bg="gray", font=("Helvtica", 32))
    # my_label2.pack()
    # state_name_entry.delete(0, tk.END)
    # state_name_entry.insert(0, "")
    print(parameter)

def new_control():
    global control
    control.append([control_name_entry.get(), [control_left_inter_edit_entry.get(), control_right_inter_edit_entry.get(), control_step_inter_edit_entry.get()], 0, "", ""])
    print(control)
    
def new_matrix():
    global matrix
    list_mat_expr = []
    list_mat_math = []
    mat_1_ = int(matrix_len_1_edit_entry_text.get())
    mat_2_ = int(matrix_len_2_edit_entry_text.get())
    l_i = []
    l_i_m = []
    # for i_l_ in range(0, mat_2_):
    #     l_i.append("")
    #     l_i_m.append("")
    for j_l_ in range(0, mat_1_):
        l_i = []
        l_i_m = []
        for i_l_ in range(0, mat_2_):
            l_i.append("")
            l_i_m.append("")
        list_mat_expr.append(l_i)
        list_mat_math.append(l_i_m)
    matrix.append([matrix_name_entry.get(), list_mat_expr, 0, "", list_mat_math, mat_1_, mat_2_])
    # my_label2 = tk.Label(main_window, text=state_name_entry.get(), fg="blue", bg="gray", font=("Helvtica", 32))
    # my_label2.pack()
    # state_name_entry.delete(0, tk.END)
    # state_name_entry.insert(0, "")
    print(matrix)


def new_matrix_value():
    for i_l_ in range(0, len(matrix_val_new_entry_text)):
        for j_l_ in range(0, len(matrix_val_new_entry_text[-1])):
            print("i=", i_l_, "j=", j_l_, "m=", matrix_val_new_entry_text[i_l_][j_l_].get())
            matrix[-1][1][i_l_][j_l_] = matrix_val_new_entry_text[i_l_][j_l_].get()
            print("m11=", matrix)

def new_matrix_expr():
    matrix[-1][1] = matrix_expr_new_entry_text.get()

def edit_parameter(ind_):
    parameter[ind_][1] = parameter_expr_edit_entry.get()

def edit_matrix(ind_):
    list_mat_expr = []
    list_mat_math = []
    for j_l_ in range(0, int(matrix[ind_][5])):
        l_i = []
        l_i_m = []
        for i_l_ in range(0, int(matrix[ind_][6])):
            l_i.append("")
            l_i_m.append("")
        list_mat_expr.append(l_i)
        list_mat_math.append(l_i_m)
    matrix[ind_][1] = list_mat_expr
    for i_l_ in range(0, len(list_matrix_expr_edit_entry)):
        for j_l_ in range(0, len(list_matrix_expr_edit_entry[-1])):
            matrix[ind_][1][i_l_][j_l_] = list_matrix_expr_edit_entry[i_l_][j_l_].get()
    matrix[ind_][4] = replace_exprs_to_math(matrix[ind_][1])

def edit_matrix_expr(ind_):
    matrix[ind_][1] = matrix_expr_edit_entry.get()

def edit_control(ind_):
    control[ind_][1] = [control_left_inter_edit_entry.get(), control_right_inter_edit_entry.get(), control_step_inter_edit_entry.get()]
    
def delete_parameter():
    global delete_parameter_window
    delete_parameter_window = tk.Toplevel()
    delete_parameter_window.title("Delete parameter")
    delete_parameter_window.geometry("300x400")

    global delete_parameters_frame
    delete_parameters_frame = tk.Frame(delete_parameter_window, borderwidth=1, bd=1, relief=tk.SUNKEN)
    parameters_list_label = tk.Label(delete_parameters_frame, text="parameters:", font=("Helvtica", 24))
    global list_parameters_delete_labels
    list_parameters_delete_labels = []
    for i_parameters_name_ in range(0, len(list_parameters_imgs)):
        list_parameters_delete_labels.append(
            tk.Label(delete_parameters_frame, image=list_parameters_name_imgs[i_parameters_name_]))

    list_parameters_delete_button = []
    for i_parameters_name_ in range(0, len(list_parameters_imgs)):
        print("i_parameters_name_=", i_parameters_name_)
        list_parameters_delete_button.append(
            tk.Button(delete_parameters_frame, text='Delete', image=delete_icon, compound=tk.LEFT,
                      command=lambda i_parameters1=i_parameters_name_: delete_parameter_submit(i_parameters1)))
    parameters_list_label.grid(row=0, column=0)

    for i_parameters_name_ in range(0, len(list_parameters_delete_labels)):
        list_parameters_delete_labels[i_parameters_name_].grid(row=i_parameters_name_ + 1, column=0, sticky="W", pady=10)
        list_parameters_delete_button[i_parameters_name_].grid(row=i_parameters_name_ + 1, column=1, sticky="W", padx=30, pady=10)
    delete_parameters_frame.grid(row=0, column=0, padx=20, pady=20, sticky="W")
    delete_parameter_window.mainloop()

def delete_parameter_submit(ind_):
    parameter.pop(ind_)
    list_parameters_name_imgs.pop(ind_)
    list_parameters_imgs.pop(ind_)
    list_parameters_labels.pop(ind_)
    list_parameters_edit_button.pop(ind_)
    parameters_frame.grid_forget()
    parameters_list_label.grid(row=0, column=0)
    for label1 in parameters_frame.grid_slaves():
        if int(label1.grid_info()["row"]) > 0:
            label1.grid_forget()
    for i_parameters in range(0, len(list_parameters_labels)):
        # list_parameters_labels[i_parameters].destroy()
        # list_parameters_edit_button[i_parameters].grid_forget()
        list_parameters_edit_button[i_parameters] = tk.Button(parameters_frame, text='Edit', image=edit_icon, compound=tk.LEFT, command=lambda i_parameters1=i_parameters: open_edit_parameter_window(i_parameters1))
        list_parameters_labels[i_parameters].grid(row=i_parameters + 1, column=0, sticky="W", pady=10)
        list_parameters_edit_button[i_parameters].grid(row=i_parameters + 1, column=1, sticky="W", padx=30, pady=10)
    new_parameter_button.grid(row=len(list_parameters_labels) + 1, column=0, pady=30)
    parameters_frame.grid(row=0, column=1, padx=20, pady=20, sticky="N")
    delete_parameter_window.withdraw()

def delete_matrix():
    global delete_matrix_window
    delete_matrix_window = tk.Toplevel()
    delete_matrix_window.title("Delete matrix")
    delete_matrix_window.geometry("300x400")

    global delete_matrices_frame
    delete_matrices_frame = tk.Frame(delete_matrix_window, borderwidth=1, bd=1, relief=tk.SUNKEN)
    matrices_list_label = tk.Label(delete_matrices_frame, text="matrices:", font=("Helvtica", 24))
    global list_matrices_delete_labels
    list_matrices_delete_labels = []
    for i_matrices_name_ in range(0, len(list_matrices_name_imgs)):
        list_matrices_delete_labels.append(
            tk.Label(delete_matrices_frame, image=list_matrices_name_imgs[i_matrices_name_]))

    list_matrices_delete_button = []
    for i_matrices_name_ in range(0, len(list_matrices_name_imgs)):
        print("i_matrices_name_=", i_matrices_name_)
        list_matrices_delete_button.append(
            tk.Button(delete_matrices_frame, text='Delete', image=delete_icon, compound=tk.LEFT,
                      command=lambda i_matrices1=i_matrices_name_: delete_matrix_submit(i_matrices1)))
    matrices_list_label.grid(row=0, column=0)

    for i_matrices_name_ in range(0, len(list_matrices_delete_labels)):
        list_matrices_delete_labels[i_matrices_name_].grid(row=i_matrices_name_ + 1, column=0, sticky="W", pady=10)
        list_matrices_delete_button[i_matrices_name_].grid(row=i_matrices_name_ + 1, column=1, sticky="W", padx=30, pady=10)
    delete_matrices_frame.grid(row=0, column=0, padx=20, pady=20, sticky="W")
    delete_matrix_window.mainloop()
    
def delete_matrix_submit(ind_):
    matrix.pop(ind_)
    list_matrices_name_imgs.pop(ind_)
    # list_matrices_imgs.pop(ind_)
    list_matrices_labels.pop(ind_)
    list_matrices_edit_button.pop(ind_)
    matrices_frame.grid_forget()
    matrices_list_label.grid(row=0, column=0)
    for label1 in matrices_frame.grid_slaves():
        if int(label1.grid_info()["row"]) > 0:
            label1.grid_forget()
    for i_matrices in range(0, len(list_matrices_labels)):
        # list_matrices_labels[i_matrices].destroy()
        # list_matrices_edit_button[i_matrices].grid_forget()
        list_matrices_edit_button[i_matrices] = tk.Button(matrices_frame, text='Edit', image=edit_icon, compound=tk.LEFT, command=lambda i_matrices1=i_matrices: open_edit_matrix_window(i_matrices1))
        list_matrices_labels[i_matrices].grid(row=i_matrices + 1, column=0, sticky="W", pady=10)
        list_matrices_edit_button[i_matrices].grid(row=i_matrices + 1, column=1, sticky="W", padx=30, pady=10)
    new_matrix_button.grid(row=len(list_matrices_labels) + 1, column=0, pady=30)
    matrices_frame.grid(row=0, column=1, padx=20, pady=20, sticky="N")
    delete_matrix_window.withdraw()
    
    
def delete_control():
    global delete_control_window
    delete_control_window = tk.Toplevel()
    delete_control_window.title("Delete control")
    delete_control_window.geometry("300x400")

    global delete_controls_frame
    delete_controls_frame = tk.Frame(delete_control_window, borderwidth=1, bd=1, relief=tk.SUNKEN)
    controls_list_label = tk.Label(delete_controls_frame, text="controls:", font=("Helvtica", 24))
    global list_controls_delete_labels
    list_controls_delete_labels = []
    for i_controls_name_ in range(0, len(list_controls_name_imgs)):
        list_controls_delete_labels.append(
            tk.Label(delete_controls_frame, image=list_controls_name_imgs[i_controls_name_]))

    list_controls_delete_button = []
    for i_controls_name_ in range(0, len(list_controls_name_imgs)):
        print("i_controls_name_=", i_controls_name_)
        list_controls_delete_button.append(
            tk.Button(delete_controls_frame, text='Delete', image=delete_icon, compound=tk.LEFT,
                      command=lambda i_controls1=i_controls_name_: delete_control_submit(i_controls1)))
    controls_list_label.grid(row=0, column=0)

    for i_controls_name_ in range(0, len(list_controls_delete_labels)):
        list_controls_delete_labels[i_controls_name_].grid(row=i_controls_name_ + 1, column=0, sticky="W", pady=10)
        list_controls_delete_button[i_controls_name_].grid(row=i_controls_name_ + 1, column=1, sticky="W", padx=30, pady=10)
    delete_controls_frame.grid(row=0, column=0, padx=20, pady=20, sticky="W")
    delete_control_window.mainloop()

def delete_control_submit(ind_):
    control.pop(ind_)
    list_controls_name_imgs.pop(ind_)
    list_controls_labels.pop(ind_)
    list_controls_edit_button.pop(ind_)
    controls_frame.grid_forget()
    controls_list_label.grid(row=0, column=0)
    for label1 in controls_frame.grid_slaves():
        if int(label1.grid_info()["row"]) > 0:
            label1.grid_forget()
    for i_controls in range(0, len(list_controls_labels)):
        # list_controls_labels[i_controls].destroy()
        # list_controls_edit_button[i_controls].grid_forget()
        list_controls_edit_button[i_controls] = tk.Button(controls_frame, text='Edit', image=edit_icon, compound=tk.LEFT, command=lambda i_controls1=i_controls: open_edit_control_window(i_controls1))
        list_controls_labels[i_controls].grid(row=i_controls + 1, column=0, sticky="W", pady=10)
        list_controls_edit_button[i_controls].grid(row=i_controls + 1, column=1, sticky="W", padx=30, pady=10)
    new_control_button.grid(row=len(list_controls_labels) + 1, column=0, pady=30)
    controls_frame.grid(row=0, column=1, padx=20, pady=20, sticky="N")
    delete_control_window.withdraw()


def submit_new_state_button_command():
    new_state()
    refresh_add_state_main_window()
    new_state_window.withdraw()

def submit_new_state_entry_command(event):
    new_state()
    refresh_add_state_main_window()
    new_state_window.withdraw()

def open_new_state_window():
    global new_state_window
    new_state_window = tk.Toplevel()
    new_state_window.title("Add new state")
    new_state_window.geometry("270x150")
    global state_name_entry
    new_state_window_label = tk.Label(new_state_window, text="Give the state name:", fg="blue", bg="gray", font=("Helvtica", 18))
    state_name_entry = tk.Entry(new_state_window, font=("Helvtica", 16))
    state_name_entry.bind('<Return>', submit_new_state_entry_command)
    submit_new_state_button = tk.Button(new_state_window, text="Submit", command=submit_new_state_button_command)
    new_state_window_label.grid(row=0, column=0, pady=10)
    state_name_entry.grid(padx=10, pady=10)
    submit_new_state_button.grid(pady=10)
    new_state_window.mainloop()

def refresh_states_main_window():
    global list_states_imgs
    global list_states_labels
    list_states_imgs = get_images_of_state_eq(state)
    list_states_labels = []
    for i_states_ in range(0, len(list_states_imgs)):
        list_states_labels.append(tk.Label(states_frame, image=list_states_imgs[i_states_]))
    states_list_label.grid(row=0, column=0)
    for i_states_ in range(0, len(list_states_labels)):
        list_states_labels[i_states_].grid(row=i_states_ + 1, column=0, sticky="W", pady=10)
    new_state_button.grid(row=len(list_states_labels) + 1, column=0, pady=30)
    new_guard_reset_button.grid(row=len(list_states_labels) + 2, column=0, pady=10)

def refresh_add_state_main_window():
    global list_states_imgs
    global list_states_labels
    global list_states_name_imgs
    global list_states_name_point_imgs
    global list_states_labels
    g_i_s_n_, l_s_n_ = get_images_of_state_name([state[-1]])
    state[-1][3] = l_s_n_[0]
    state[-1][4] = replace_exprs_to_math(state[-1][1])
    list_states_imgs.append(get_images_of_state_eq([state[-1]])[0])
    list_states_name_imgs.append(g_i_s_n_[0])
    list_states_name_point_imgs.append(get_images_of_state_name_point([state[-1]])[0])
    list_states_labels.append(tk.Label(states_frame, image=list_states_imgs[-1]))
    list_states_edit_button.append(tk.Button(states_frame, text='Edit', image=edit_icon, compound=tk.LEFT, command=lambda index_=len(list_states_labels)-1: open_edit_state_window(index_)))

    states_list_label.grid(row=0, column=0)
    for i_states_ in range(0, len(list_states_labels)):
        list_states_labels[i_states_].grid(row=i_states_ + 1, column=0, sticky="W", pady=10)
        list_states_edit_button[i_states_].grid(row=i_states_ + 1, column=1, sticky="W", padx=0, pady=10)
    new_state_button.grid(row=len(list_states_labels) + 1, column=0, pady=30)
    new_guard_reset_button.grid(row=len(list_states_labels) + 2, column=0, pady=10)

def open_edit_state_window(ind):
    global edit_state_window
    print("ind=", ind)
    edit_state_window = tk.Toplevel()
    edit_state_window.title("Edit state")
    edit_state_window.geometry("600x500")
    edit_state_window_label = tk.Label(edit_state_window, text="Edit state equation:", fg="blue", bg="gray", font=("Helvtica", 18))

    # state_name_edit_entry_text = tk.StringVar()
    # global state_name_edit_entry
    # state_name_edit_entry = tk.Entry(edit_state_window, width="5", font=("Helvtica", 16), textvariable=state_name_edit_entry_text)
    # state_name_edit_entry_text.set(state[ind][0])
    entry_frame = tk.Frame(edit_state_window)
    state_name_edit_label = tk.Label(entry_frame, image=list_states_name_point_imgs[ind])
    edit_state_window_eq_label = tk.Label(entry_frame, text=" = ", fg="black", font=("Helvtica", 18))
    global state_expr_edit_entry_text
    state_expr_edit_entry_text = tk.StringVar()
    global state_expr_edit_entry
    state_expr_edit_entry = tk.Entry(entry_frame, font=("Helvtica", 16), textvariable=state_expr_edit_entry_text)
    state_expr_edit_entry_text.set(state[ind][1])
    # state_name_edit_entry.bind('<Return>', lambda event, ind_1=ind: submit_edit_state_entry_command(event, ind_1))
    state_expr_edit_entry.bind('<Return>', lambda event, ind_1=ind: submit_edit_state_entry_command(event, ind_1))
    submit_edit_state_button = tk.Button(entry_frame, text="Submit", command=lambda ind_1=ind: submit_edit_state_button_command(ind_1))

    states_parameters_frame = tk.Frame(edit_state_window, borderwidth=1, bd=1, relief=tk.SUNKEN)
    state_name_label = tk.Label(states_parameters_frame, text=" States: ", fg="black", font=("Helvtica", 14))
    state_name_label.grid(row=0, column=0, pady=10, columnspan=3, sticky="W")
    list_submit_edit_state_button = []
    cur_row = 1
    cur_column = 0
    for i_states_ in range(0, len(state)):
        submit_add_state_button = tk.Button(states_parameters_frame, image=list_states_name_imgs[i_states_], command=lambda ind_1=i_states_: add_state_to_entry_expr_button_command(ind_1))
        list_submit_edit_state_button.append(submit_add_state_button)
        list_submit_edit_state_button[i_states_].grid(row=cur_row, column=cur_column, pady=10, sticky="W", padx=10)
        cur_column += 1
        if i_states_ % 3 == 2:
            cur_row += 1
            cur_column = 0
    parameter_name_label = tk.Label(states_parameters_frame, text=" Parameters: ", fg="black", font=("Helvtica", 14))
    cur_row += 1
    parameter_name_label.grid(row=cur_row, column=0, pady=10, columnspan=3, sticky="W")
    cur_row += 1
    cur_column = 0
    list_submit_edit_parameter_button = []
    for i_parameters_ in range(0, len(parameter)):
        submit_add_parameter_button = tk.Button(states_parameters_frame, image=list_parameters_name_imgs[i_parameters_], command=lambda ind_1=i_parameters_: add_parameter_to_entry_expr_button_command(ind_1))
        list_submit_edit_parameter_button.append(submit_add_parameter_button)
        list_submit_edit_parameter_button[i_parameters_].grid(row=cur_row, column=cur_column, padx=10, pady=10, sticky="W")
        cur_column += 1
        if i_parameters_ % 3 == 2:
            cur_row += 1
            cur_column = 0

    matrix_name_label = tk.Label(states_parameters_frame, text=" Matrices: ", fg="black", font=("Helvtica", 14))
    cur_row += 1
    matrix_name_label.grid(row=cur_row, column=0, pady=10, columnspan=3, sticky="W")
    cur_row += 1
    cur_column = 0
    list_submit_edit_matrix_button = []
    for i_matrices_ in range(0, len(matrix)):
        submit_add_matrix_button = tk.Button(states_parameters_frame, image=list_matrices_name_imgs[i_matrices_], command=lambda ind_1=i_matrices_: add_matrix_to_entry_expr_button_command(ind_1))
        list_submit_edit_matrix_button.append(submit_add_matrix_button)
        list_submit_edit_matrix_button[i_matrices_].grid(row=cur_row, column=cur_column, padx=10, pady=10, sticky="W")
        cur_column += 1
        if i_matrices_ % 3 == 2:
            cur_row += 1
            cur_column = 0

    edit_state_window_label.grid(row=0, column=0, columnspan=2, pady=10)
    # state_name_edit_entry.grid(row=1, column=0, padx=3, pady=10)
    state_name_edit_label.grid(row=0, column=0, padx=3, pady=10)
    edit_state_window_eq_label.grid(row=0, column=1, padx=3, pady=10)
    state_expr_edit_entry.grid(row=0, column=2, padx=3, pady=10)
    submit_edit_state_button.grid(row=1, column=0, columnspan=3, pady=10)
    entry_frame.grid(row=1, column=0, pady=10)
    states_parameters_frame.grid(row=1, column=1, rowspan=2, pady=10, padx=10)
    edit_state_window.mainloop()

def add_state_to_entry_expr_button_command(ind_):
    print("idddd_", ind_)
    state_expr_edit_entry_text.set(state_expr_edit_entry_text.get()+state[ind_][0])

def add_parameter_to_entry_expr_button_command(ind_):
    print("idddd_", ind_)
    state_expr_edit_entry_text.set(state_expr_edit_entry_text.get()+parameter[ind_][0])

def add_matrix_to_entry_expr_button_command(ind_):
    print("idddd_", ind_)
    state_expr_edit_entry_text.set(state_expr_edit_entry_text.get()+matrix[ind_][0])

def submit_edit_state_entry_command(event, ind_):
    print("idddd_", ind_)
    print("event", event)
    edit_state(ind_)
    refresh_edit_state_main_window(ind_)
    edit_state_window.withdraw()

def submit_edit_state_button_command(ind_):
    edit_state(ind_)
    refresh_edit_state_main_window(ind_)
    edit_state_window.withdraw()

def refresh_edit_state_main_window(ind_):
    global list_states_imgs
    global list_states_labels
    state[ind_][4] = replace_exprs_to_math(state[ind_][1])
    list_states_imgs[ind_] = get_images_of_state_eq([state[ind_]])[0]
    list_states_labels[ind_] = tk.Label(states_frame, image=list_states_imgs[ind_])

    states_list_label.grid(row=0, column=0)
    for i_states_ in range(0, len(list_states_labels)):
        list_states_labels[i_states_].grid(row=i_states_ + 1, column=0, sticky="W", pady=10)
        list_states_edit_button[i_states_].grid(row=i_states_ + 1, column=1, sticky="W", padx=0, pady=10)
    new_state_button.grid(row=len(list_states_labels) + 1, column=0, pady=30)
    new_guard_reset_button.grid(row=len(list_states_labels) + 2, column=0, pady=10)

def open_new_parameter_window():
    global new_parameter_window
    new_parameter_window = tk.Toplevel()
    new_parameter_window.title("Add new parameter")
    new_parameter_window.geometry("700x500")
    global parameter_name_entry
    new_parameter_window_label = tk.Label(new_parameter_window, text="Give the parameter name and its value:", fg="blue", bg="gray", font=("Helvtica", 18))
    entry_new_parameter_frame = tk.Frame(new_parameter_window)
    new_parameter_window_eq_label = tk.Label(entry_new_parameter_frame, text=" = ", fg="black", font=("Helvtica", 18))

    parameter_name_entry = tk.Entry(entry_new_parameter_frame, width="5", font=("Helvtica", 16))
    global parameter_expr_edit_entry_text
    parameter_expr_edit_entry_text = tk.StringVar()
    global parameter_expr_edit_entry
    parameter_expr_edit_entry = tk.Entry(entry_new_parameter_frame, font=("Helvtica", 16), textvariable=parameter_expr_edit_entry_text)

    states_parameters_frame = tk.Frame(new_parameter_window, borderwidth=1, bd=1, relief=tk.SUNKEN)
    state_name_label = tk.Label(states_parameters_frame, text=" States: ", fg="black", font=("Helvtica", 14))
    state_name_label.grid(row=0, column=0, pady=10, columnspan=3, sticky="W")
    list_submit_edit_state_button = []
    cur_row = 1
    cur_column = 0
    for i_states_ in range(0, len(state)):
        submit_add_state_button = tk.Button(states_parameters_frame, image=list_states_name_imgs[i_states_], command=lambda ind_1=i_states_: add_state_to_entry_expr_new_param_button_command(ind_1))
        list_submit_edit_state_button.append(submit_add_state_button)
        list_submit_edit_state_button[i_states_].grid(row=cur_row, column=cur_column, pady=10, sticky="W", padx=10)
        cur_column += 1
        if i_states_ % 3 == 2:
            cur_row += 1
            cur_column = 0
    parameter_name_label = tk.Label(states_parameters_frame, text=" Parameters: ", fg="black", font=("Helvtica", 14))
    cur_row += 1
    parameter_name_label.grid(row=cur_row, column=0, pady=10, columnspan=3, sticky="W")
    cur_row += 1
    cur_column = 0
    list_submit_edit_parameter_button = []
    for i_parameters_ in range(0, len(parameter)):
        submit_add_parameter_button = tk.Button(states_parameters_frame, image=list_parameters_name_imgs[i_parameters_], command=lambda ind_1=i_parameters_: add_parameter_to_entry_expr_new_param_button_command(ind_1))
        list_submit_edit_parameter_button.append(submit_add_parameter_button)
        list_submit_edit_parameter_button[i_parameters_].grid(row=cur_row, column=cur_column, padx=10, pady=10, sticky="W")
        cur_column += 1
        if i_parameters_ % 3 == 2:
            cur_row += 1
            cur_column = 0

    matrix_name_label = tk.Label(states_parameters_frame, text=" Matrices: ", fg="black", font=("Helvtica", 14))
    cur_row += 1
    matrix_name_label.grid(row=cur_row, column=0, pady=10, columnspan=3, sticky="W")
    cur_row += 1
    cur_column = 0
    list_submit_edit_matrix_button = []
    for i_matrices_ in range(0, len(matrix)):
        submit_add_matrix_button = tk.Button(states_parameters_frame, image=list_matrices_name_imgs[i_matrices_], command=lambda ind_1=i_matrices_: add_matrix_to_entry_expr_new_param_button_command(ind_1))
        list_submit_edit_matrix_button.append(submit_add_matrix_button)
        list_submit_edit_matrix_button[i_matrices_].grid(row=cur_row, column=cur_column, padx=10, pady=10, sticky="W")
        cur_column += 1
        if i_matrices_ % 3 == 2:
            cur_row += 1
            cur_column = 0
    parameter_name_entry.bind('<Return>', submit_new_parameter_entry_command)
    parameter_expr_edit_entry.bind('<Return>', submit_new_parameter_entry_command)
    submit_new_parameter_button = tk.Button(entry_new_parameter_frame, text="Submit", command=submit_new_parameter_button_command)
    new_parameter_window_label.grid(row=0, column=0, columnspan=2, pady=10)
    parameter_name_entry.grid(row=0, column=0, padx=3, pady=10)
    new_parameter_window_eq_label.grid(row=0, column=1, padx=3, pady=10)
    parameter_expr_edit_entry.grid(row=0, column=2, padx=3, pady=10)
    submit_new_parameter_button.grid(row=1, column=0, columnspan=3, pady=10)

    entry_new_parameter_frame.grid(row=1, column=0, pady=10)
    states_parameters_frame.grid(row=1, column=1, rowspan=2, pady=10, padx=10)

    # edit_state_window_label.grid(row=0, column=0, columnspan=3, pady=10)
    # state_name_edit_entry.grid(row=1, column=0, padx=3, pady=10)
    # edit_state_window_eq_label.grid(row=1, column=1, padx=3, pady=10)
    # state_expr_edit_entry.grid(row=1, column=2, padx=3, pady=10)
    # submit_edit_state_button.grid(row=2, column=0, columnspan=3, pady=10)

    new_parameter_window.mainloop()

def add_state_to_entry_expr_new_param_button_command(ind_):
    parameter_expr_edit_entry_text.set(parameter_expr_edit_entry_text.get() + state[ind_][0])


def add_parameter_to_entry_expr_new_param_button_command(ind_):
    parameter_expr_edit_entry_text.set(parameter_expr_edit_entry_text.get() + parameter[ind_][0])

def add_matrix_to_entry_expr_new_param_button_command(ind_):
    parameter_expr_edit_entry_text.set(parameter_expr_edit_entry_text.get() + matrix[ind_][0])

def submit_new_parameter_entry_command(event):
    new_parameter()
    refresh_add_parameter_main_window()
    new_parameter_window.withdraw()


def submit_new_parameter_button_command():
    new_parameter()
    refresh_add_parameter_main_window()
    new_parameter_window.withdraw()

def replace_exprs_to_math(str_):
    r_ = str_
    for l_s_ in state:
        r_ = r_.replace(l_s_[0], l_s_[3])
    for l_p_ in parameter:
        r_ = r_.replace(l_p_[0], l_p_[3])

    return r_

def refresh_add_parameter_main_window():
    global list_parameters_imgs
    global list_parameters_name_imgs
    global list_parameters_labels
    g_i_p_n_, p_n_ = get_images_of_parameter_name([parameter[-1]])
    parameter[-1][3] = p_n_[0]
    parameter[-1][4] = replace_exprs_to_math(parameter[-1][1])
    print("g_i_p_n_=", g_i_p_n_)
    print("p_n_=", p_n_)
    print("parameter=", parameter)
    # print("g_i_p_n_=",g_i_p_n_)
    list_parameters_name_imgs.append(g_i_p_n_[0])
    list_parameters_imgs.append(get_images_of_parameter_eq([parameter[-1]])[0])
    list_parameters_labels.append(tk.Label(parameters_frame, image=list_parameters_imgs[-1]))
    list_parameters_edit_button.append(tk.Button(parameters_frame, text='Edit', image=edit_icon, compound=tk.LEFT, command=lambda index_=len(list_parameters_labels) - 1: open_edit_parameter_window(index_)))
    parameters_list_label.grid(row=0, column=0)
    for i_parameters_ in range(0, len(list_parameters_labels)):
        list_parameters_labels[i_parameters_].grid(row=i_parameters_ + 1, column=0, sticky="W", pady=10)
        list_parameters_edit_button[i_parameters_].grid(row=i_parameters_ + 1, column=1, sticky="W", padx=0, pady=10)
    new_parameter_button.grid(row=len(list_parameters_labels) + 1, column=0, pady=30)

def refresh_add_matrix_main_window():
    # global list_matrices_imgs
    global list_matrices_name_imgs
    global list_matrices_labels
    g_i_p_n_, p_n_ = get_images_of_matrix_name([matrix[-1]])
    matrix[-1][3] = p_n_[0]
    for i_ in range(0, len(matrix[-1][1])):
        for j_ in range(0, len(matrix[-1][1][-1])):
            matrix[-1][4][i_][j_] = replace_exprs_to_math(matrix[-1][1][i_][j_])
    print("g_i_p_n_=", g_i_p_n_)
    print("p_n_=", p_n_)
    print("matrix=", matrix)
    # print("g_i_p_n_=",g_i_p_n_)
    list_matrices_name_imgs.append(g_i_p_n_[0])
    # list_matrices_imgs.append(get_images_of_matrix_eq([matrix[-1]])[0])
    list_matrices_labels.append(tk.Label(matrices_frame, image=list_matrices_name_imgs[-1]))
    list_matrices_edit_button.append(tk.Button(matrices_frame, text='Edit', image=edit_icon, compound=tk.LEFT, command=lambda index_=len(list_matrices_labels) - 1: open_edit_matrix_window(index_)))
    matrices_list_label.grid(row=0, column=0)
    for i_matrices_ in range(0, len(list_matrices_labels)):
        list_matrices_labels[i_matrices_].grid(row=i_matrices_ + 1, column=0, sticky="W", pady=10)
        list_matrices_edit_button[i_matrices_].grid(row=i_matrices_ + 1, column=1, sticky="W", padx=0, pady=10)
    new_matrix_button.grid(row=len(list_matrices_labels) + 1, column=0, pady=30)

def refresh_add_matrix_expr_main_window():
    # global list_matrices_imgs
    global list_matrices_name_imgs
    global list_matrices_labels
    g_i_p_n_, p_n_ = get_images_of_matrix_name([matrix[-1]])
    matrix[-1][3] = p_n_[0]
    matrix[-1][4] = replace_exprs_to_math(matrix[-1][1])
    print("g_i_p_n_=", g_i_p_n_)
    print("p_n_=", p_n_)
    print("matrix=", matrix)
    # print("g_i_p_n_=",g_i_p_n_)
    list_matrices_name_imgs.append(g_i_p_n_[0])
    # list_matrices_imgs.append(get_images_of_matrix_eq([matrix[-1]])[0])
    list_matrices_labels.append(tk.Label(matrices_frame, image=list_matrices_name_imgs[-1]))
    list_matrices_edit_button.append(tk.Button(matrices_frame, text='Edit', image=edit_icon, compound=tk.LEFT, command=lambda index_=len(list_matrices_labels) - 1: open_edit_matrix_window(index_)))
    matrices_list_label.grid(row=0, column=0)
    for i_matrices_ in range(0, len(list_matrices_labels)):
        list_matrices_labels[i_matrices_].grid(row=i_matrices_ + 1, column=0, sticky="W", pady=10)
        list_matrices_edit_button[i_matrices_].grid(row=i_matrices_ + 1, column=1, sticky="W", padx=0, pady=10)
    new_matrix_button.grid(row=len(list_matrices_labels) + 1, column=0, pady=30)

def open_new_matrix_window():
    global new_matrix_window
    new_matrix_window = tk.Toplevel()
    new_matrix_window.title("Add new matrix")
    new_matrix_window.geometry("700x500")
    global matrix_name_entry
    new_matrix_window_label = tk.Label(new_matrix_window, text="Give the matrix name and its lengths:", fg="blue", bg="gray", font=("Helvtica", 18))
    entry_new_matrix_frame = tk.Frame(new_matrix_window)
    new_matrix_window_eq_label = tk.Label(entry_new_matrix_frame, text=" = ", fg="black", font=("Helvtica", 18))
    new_matrix_window_par_left_label = tk.Label(entry_new_matrix_frame, text=" ( ", fg="black", font=("Helvtica", 18))
    new_matrix_window_comma_label = tk.Label(entry_new_matrix_frame, text=" , ", fg="black", font=("Helvtica", 18))
    new_matrix_window_par_right_label = tk.Label(entry_new_matrix_frame, text=" ) ", fg="black", font=("Helvtica", 18))

    matrix_name_entry = tk.Entry(entry_new_matrix_frame, width="5", font=("Helvtica", 16))
    global matrix_len_1_edit_entry_text
    global matrix_len_2_edit_entry_text
    matrix_len_1_edit_entry_text = tk.StringVar()
    matrix_len_2_edit_entry_text = tk.StringVar()
    global matrix_len_1_edit_entry
    global matrix_len_2_edit_entry
    matrix_len_1_edit_entry = tk.Entry(entry_new_matrix_frame, font=("Helvtica", 16), textvariable=matrix_len_1_edit_entry_text, width="3")
    matrix_len_2_edit_entry = tk.Entry(entry_new_matrix_frame, font=("Helvtica", 16), textvariable=matrix_len_2_edit_entry_text, width="3")

    matrix_name_entry.bind('<Return>', submit_new_matrix_entry_command)
    matrix_len_1_edit_entry.bind('<Return>', submit_new_matrix_entry_command)
    matrix_len_2_edit_entry.bind('<Return>', submit_new_matrix_entry_command)
    submit_new_matrix_button = tk.Button(entry_new_matrix_frame, text="Submit", command=submit_new_matrix_button_command)
    new_matrix_window_label.grid(row=0, column=0, columnspan=2, pady=10)
    matrix_name_entry.grid(row=0, column=0, padx=3, pady=10)
    new_matrix_window_eq_label.grid(row=0, column=1, padx=3, pady=10)
    new_matrix_window_par_left_label.grid(row=0, column=2, padx=3, pady=10)
    matrix_len_1_edit_entry.grid(row=0, column=3, padx=3, pady=10)
    new_matrix_window_comma_label.grid(row=0, column=4, padx=3, pady=10)
    matrix_len_2_edit_entry.grid(row=0, column=5, padx=3, pady=10)
    new_matrix_window_par_right_label.grid(row=0, column=6, padx=3, pady=10)

    submit_new_matrix_button.grid(row=1, column=0, columnspan=3, pady=10)

    entry_new_matrix_frame.grid(row=1, column=0, pady=10)

    # edit_state_window_label.grid(row=0, column=0, columnspan=3, pady=10)
    # state_name_edit_entry.grid(row=1, column=0, padx=3, pady=10)
    # edit_state_window_eq_label.grid(row=1, column=1, padx=3, pady=10)
    # state_expr_edit_entry.grid(row=1, column=2, padx=3, pady=10)
    # submit_edit_state_button.grid(row=2, column=0, columnspan=3, pady=10)

    new_matrix_window.mainloop()

def submit_new_matrix_button_command():
    new_matrix()
    global new_matrix_val_window
    new_matrix_val_window = tk.Toplevel()
    new_matrix_val_window.title("Add new matrix")
    new_matrix_val_window.geometry("700x500")
    new_matrix_val_window_label = tk.Label(new_matrix_val_window, text="Give the matrix elements values:", fg="blue", bg="gray", font=("Helvtica", 18))
    entry_new_matrix_val_frame = tk.Frame(new_matrix_val_window)
    new_matrix_val_window_eq_label = tk.Label(entry_new_matrix_val_frame, text=" = ", fg="black", font=("Helvtica", 18))
    matrix_name_label_f = tk.Label(entry_new_matrix_val_frame, text=matrix[-1][0], font=("Helvtica", 16))

    global matrix_val_new_entry_text
    global matrix_val_new_entry
    matrix_val_new_entry_text = []
    matrix_val_new_entry = []
    for i_ in range(0, len(matrix[-1][1])):
        l_strval = []
        for j_ in range(0, len(matrix[-1][1][-1])):
            l_strval.append(tk.StringVar())
        matrix_val_new_entry_text.append(l_strval)

    for i_ in range(0, len(matrix[-1][1])):
        l_entry = []
        for j_ in range(0, len(matrix[-1][1][-1])):
            l_entry.append(tk.Entry(entry_new_matrix_val_frame, font=("Helvtica", 16), width="8", textvariable=matrix_val_new_entry_text[i_][j_]))
        matrix_val_new_entry.append(l_entry)
    submit_new_matrix_button = tk.Button(entry_new_matrix_val_frame, text="Submit", command=submit_new_matrix_val_button_command)

    entry_new_matrix_expr_frame = tk.Frame(new_matrix_val_window)
    new_matrix_val_window_or_label = tk.Label(entry_new_matrix_expr_frame, text=" OR ", fg="black", font=("Helvtica", 18))
    matrix_name_label_expr = tk.Label(entry_new_matrix_expr_frame, text=matrix[-1][0], font=("Helvtica", 16))
    new_matrix_expr_window_eq_label = tk.Label(entry_new_matrix_expr_frame, text=" = ", fg="black", font=("Helvtica", 18))
    global matrix_expr_new_entry_text
    matrix_expr_new_entry_text = tk.StringVar()
    global matrix_expr_new_entry
    matrix_expr_new_entry = tk.Entry(entry_new_matrix_expr_frame, font=("Helvtica", 16), textvariable=matrix_expr_new_entry_text)
    submit_new_matrix_expr_button = tk.Button(entry_new_matrix_expr_frame, text="Submit", command=submit_new_matrix_expr_button_command)

    states_parameters_frame = tk.Frame(new_matrix_val_window, borderwidth=1, bd=1, relief=tk.SUNKEN)
    state_name_label = tk.Label(states_parameters_frame, text=" States: ", fg="black", font=("Helvtica", 14))
    state_name_label.grid(row=0, column=0, pady=10, columnspan=3, sticky="W")

    list_submit_edit_state_button = []
    cur_row = 1
    cur_column = 0
    for i_states_ in range(0, len(state)):
        submit_add_state_button = tk.Button(states_parameters_frame, image=list_states_name_imgs[i_states_])
        list_submit_edit_state_button.append(submit_add_state_button)
        list_submit_edit_state_button[i_states_].grid(row=cur_row, column=cur_column, pady=10, sticky="W", padx=10)
        cur_column += 1
        if i_states_ % 3 == 2:
            cur_row += 1
            cur_column = 0
    parameter_name_label = tk.Label(states_parameters_frame, text=" Parameters: ", fg="black", font=("Helvtica", 14))
    cur_row += 1
    parameter_name_label.grid(row=cur_row, column=0, pady=10, columnspan=3, sticky="W")
    cur_row += 1
    cur_column = 0
    list_submit_edit_parameter_button = []
    for i_parameters_ in range(0, len(parameter)):
        submit_add_parameter_button = tk.Button(states_parameters_frame, image=list_parameters_name_imgs[i_parameters_])
        list_submit_edit_parameter_button.append(submit_add_parameter_button)
        list_submit_edit_parameter_button[i_parameters_].grid(row=cur_row, column=cur_column, padx=10, pady=10, sticky="W")
        cur_column += 1
        if i_parameters_ % 3 == 2:
            cur_row += 1
            cur_column = 0

    matrix_name_label = tk.Label(states_parameters_frame, text=" Matrices: ", fg="black", font=("Helvtica", 14))
    cur_row += 1
    matrix_name_label.grid(row=cur_row, column=0, pady=10, columnspan=3, sticky="W")
    cur_row += 1
    cur_column = 0
    list_submit_edit_matrix_button = []
    for i_matrices_ in range(0, len(matrix)-1):
        submit_add_matrix_button = tk.Button(states_parameters_frame, image=list_matrices_name_imgs[i_matrices_])
        list_submit_edit_matrix_button.append(submit_add_matrix_button)
        list_submit_edit_matrix_button[i_matrices_].grid(row=cur_row, column=cur_column, padx=10, pady=10, sticky="W")
        cur_column += 1
        if i_matrices_ % 3 == 2:
            cur_row += 1
            cur_column = 0

    new_matrix_val_window_label.grid(row=0, column=0, columnspan=2, pady=10)

    matrix_name_label_f.grid(row=0, column=0, pady=10, padx=3)
    new_matrix_val_window_eq_label.grid(row=0, column=1, padx=3, pady=10)
    for i_ in range(0, len(matrix[-1][1])):
        for j_ in range(0, len(matrix[-1][1][-1])):
            matrix_val_new_entry[i_][j_].grid(row=i_, column=j_+2, padx=3, pady=5)
    submit_new_matrix_button.grid(row=len(matrix[-1][1]), column=0, columnspan=len(matrix[-1][1][-1])+2, pady=10)

    new_matrix_val_window_or_label.grid(row=0, column=0, pady=10, padx=3)
    matrix_name_label_expr.grid(row=1, column=0, pady=10, padx=3)
    new_matrix_expr_window_eq_label.grid(row=1, column=1, padx=3, pady=10)
    matrix_expr_new_entry.grid(row=1, column=2, padx=3, pady=10)
    submit_new_matrix_expr_button.grid(row=2, column=0, columnspan=3, pady=10)

    entry_new_matrix_val_frame.grid(row=1, column=0, rowspan=2, pady=10, padx=10)
    entry_new_matrix_expr_frame.grid(row=3, column=0, pady=10, padx=10)
    states_parameters_frame.grid(row=1, column=1, rowspan=2, pady=10, padx=10)
    new_matrix_val_window.mainloop()

def submit_new_matrix_entry_command(event_):
    submit_new_matrix_button_command()

def submit_new_matrix_val_button_command():
    new_matrix_value()
    refresh_add_matrix_main_window()
    new_matrix_val_window.withdraw()
    new_matrix_window.withdraw()

def submit_new_matrix_expr_button_command():
    new_matrix_expr()
    refresh_add_matrix_expr_main_window()
    new_matrix_val_window.withdraw()
    new_matrix_window.withdraw()


def open_new_control_window():
    global new_control_window
    new_control_window = tk.Toplevel()
    new_control_window.title("Add new control")
    new_control_window.geometry("700x500")
    global control_name_entry
    new_control_window_label = tk.Label(new_control_window, text="Give the control name, its interval and the number of steps:", fg="blue", bg="gray", font=("Helvtica", 18))
    entry_new_control_frame = tk.Frame(new_control_window)
    new_control_window_eq_label = tk.Label(entry_new_control_frame, text=" ∈ ", fg="black", font=("Helvtica", 18))
    new_control_window_bracket_left_label = tk.Label(entry_new_control_frame, text=" [", fg="black", font=("Helvtica", 18))
    new_control_window_bracket_comma_label = tk.Label(entry_new_control_frame, text=", ", fg="black", font=("Helvtica", 18))
    new_control_window_bracket_right_label = tk.Label(entry_new_control_frame, text=" ]", fg="black", font=("Helvtica", 18))
    new_control_window_step_label = tk.Label(entry_new_control_frame, text=" Step = ", fg="black", font=("Helvtica", 18))

    control_name_entry = tk.Entry(entry_new_control_frame, width="5", font=("Helvtica", 16))
    global control_left_inter_entry_text
    control_left_inter_entry_text = tk.StringVar()
    global control_left_inter_edit_entry
    control_left_inter_edit_entry = tk.Entry(entry_new_control_frame, font=("Helvtica", 16), textvariable=control_left_inter_entry_text, width="5")
    control_name_entry.bind('<Return>', submit_new_control_entry_command)
    control_left_inter_edit_entry.bind('<Return>', submit_new_control_entry_command)

    global control_right_inter_entry_text
    control_right_inter_entry_text = tk.StringVar()
    global control_right_inter_edit_entry
    control_right_inter_edit_entry = tk.Entry(entry_new_control_frame, font=("Helvtica", 16), textvariable=control_right_inter_entry_text, width="5")
    control_right_inter_edit_entry.bind('<Return>', submit_new_control_entry_command)

    global control_step_inter_entry_text
    control_step_inter_entry_text = tk.StringVar()
    global control_step_inter_edit_entry
    control_step_inter_edit_entry = tk.Entry(entry_new_control_frame, font=("Helvtica", 16), textvariable=control_step_inter_entry_text, width="5")
    control_step_inter_edit_entry.bind('<Return>', submit_new_control_entry_command)
    
    submit_new_control_button = tk.Button(entry_new_control_frame, text="Submit", command=submit_new_control_button_command)
    
    new_control_window_label.grid(row=0, column=0, columnspan=2, pady=10)
    control_name_entry.grid(row=0, column=0, padx=3, pady=10)
    new_control_window_eq_label.grid(row=0, column=1, padx=3, pady=10)
    new_control_window_bracket_left_label.grid(row=0, column=2, padx=3, pady=10)
    control_left_inter_edit_entry.grid(row=0, column=3, padx=3, pady=10)
    new_control_window_bracket_comma_label.grid(row=0, column=4, padx=3, pady=10)
    control_right_inter_edit_entry.grid(row=0, column=5, padx=3, pady=10)
    new_control_window_bracket_right_label.grid(row=0, column=6, padx=3, pady=10)
    new_control_window_step_label.grid(row=1, column=0, columnspan=3, pady=10)
    control_step_inter_edit_entry.grid(row=1, column=1, columnspan=3, pady=10)
    submit_new_control_button.grid(row=2, column=0, columnspan=3, pady=10)

    entry_new_control_frame.grid(row=1, column=0, pady=10)

    new_control_window.mainloop()

def submit_new_control_entry_command(event):
    submit_new_control_button_command()


def submit_new_control_button_command():
    new_control()
    refresh_add_control_main_window()
    new_control_window.withdraw()

def refresh_add_control_main_window():
    global list_controls_name_imgs
    global list_controls_labels
    g_i_p_n_, p_n_ = get_images_of_control_name([control[-1]])
    control[-1][3] = p_n_[0]
    print("g_i_p_n_=", g_i_p_n_)
    print("p_n_=", p_n_)
    print("control=", control)
    # print("g_i_p_n_=",g_i_p_n_)
    list_controls_name_imgs.append(g_i_p_n_[0])
    list_controls_labels.append(tk.Label(controls_frame, image=list_controls_name_imgs[-1]))
    list_controls_edit_button.append(tk.Button(controls_frame, text='Edit', image=edit_icon, compound=tk.LEFT, command=lambda index_=len(list_controls_labels) - 1: open_edit_control_window(index_)))
    controls_list_label.grid(row=0, column=0)
    for i_controls_ in range(0, len(list_controls_labels)):
        list_controls_labels[i_controls_].grid(row=i_controls_ + 1, column=0, sticky="W", pady=10)
        list_controls_edit_button[i_controls_].grid(row=i_controls_ + 1, column=1, sticky="W", padx=0, pady=10)
    new_control_button.grid(row=len(list_controls_labels) + 1, column=0, pady=30)
    
def open_edit_parameter_window(ind):
    global edit_parameter_window
    print("ind=", ind)
    edit_parameter_window = tk.Toplevel()
    edit_parameter_window.title("Edit parameter")
    edit_parameter_window.geometry("700x500")
    edit_parameter_window_label = tk.Label(edit_parameter_window, text="Edit parameter expression:", fg="blue", bg="gray", font=("Helvtica", 18))
    entry_edit_parameter_frame = tk.Frame(edit_parameter_window)

    # parameter_name_edit_entry_text = tk.StringVar()
    # global parameter_name_edit_entry
    # parameter_name_edit_entry = tk.Entry(edit_parameter_window, width="5", font=("Helvtica", 16), textvariable=parameter_name_edit_entry_text)
    # parameter_name_edit_entry_text.set(parameter[ind][0])

    parameter_name_edit_label = tk.Label(entry_edit_parameter_frame, image=list_parameters_name_imgs[ind])

    edit_parameter_window_eq_label = tk.Label(entry_edit_parameter_frame, text=" = ", fg="black", font=("Helvtica", 18))
    global parameter_expr_edit_entry_text_edit_win
    parameter_expr_edit_entry_text_edit_win = tk.StringVar()
    global parameter_expr_edit_entry
    parameter_expr_edit_entry = tk.Entry(entry_edit_parameter_frame, font=("Helvtica", 16), textvariable=parameter_expr_edit_entry_text_edit_win)
    parameter_expr_edit_entry_text_edit_win.set(parameter[ind][1])

    # parameter_name_edit_entry.bind('<Return>', lambda event, ind_1=ind: submit_edit_parameter_entry_command(event, ind_1))
    parameter_expr_edit_entry.bind('<Return>', lambda event, ind_1=ind: submit_edit_parameter_entry_command(event, ind_1))

    submit_edit_parameter_button = tk.Button(entry_edit_parameter_frame, text="Submit", command=lambda ind_1=ind: submit_edit_parameter_button_command(ind_1))

    states_parameters_frame = tk.Frame(edit_parameter_window, borderwidth=1, bd=1, relief=tk.SUNKEN)
    state_name_label = tk.Label(states_parameters_frame, text=" States: ", fg="black", font=("Helvtica", 14))
    state_name_label.grid(row=0, column=0, pady=10, columnspan=3, sticky="W")
    list_submit_edit_state_button = []
    cur_row = 1
    cur_column = 0
    for i_states_ in range(0, len(state)):
        submit_add_state_button = tk.Button(states_parameters_frame, image=list_states_name_imgs[i_states_], command=lambda ind_1=i_states_: add_state_to_entry_expr_edit_param_button_command(ind_1))
        list_submit_edit_state_button.append(submit_add_state_button)
        list_submit_edit_state_button[i_states_].grid(row=cur_row, column=cur_column, pady=10, sticky="W", padx=10)
        cur_column += 1
        if i_states_ % 3 == 2:
            cur_row += 1
            cur_column = 0
    parameter_name_label = tk.Label(states_parameters_frame, text=" Parameters: ", fg="black", font=("Helvtica", 14))
    cur_row += 1
    parameter_name_label.grid(row=cur_row, column=0, pady=10, columnspan=3, sticky="W")
    cur_row += 1
    cur_column = 0
    list_submit_edit_parameter_button = []
    for i_parameters_ in range(0, len(parameter)):
        submit_add_parameter_button = tk.Button(states_parameters_frame, image=list_parameters_name_imgs[i_parameters_], command=lambda ind_1=i_parameters_: add_parameter_to_entry_expr_edit_param_button_command(ind_1))
        list_submit_edit_parameter_button.append(submit_add_parameter_button)
        list_submit_edit_parameter_button[i_parameters_].grid(row=cur_row, column=cur_column, padx=10, pady=10, sticky="W")
        cur_column += 1
        if i_parameters_ % 3 == 2:
            cur_row += 1
            cur_column = 0

    matrix_name_label = tk.Label(states_parameters_frame, text=" Matrices: ", fg="black", font=("Helvtica", 14))
    cur_row += 1
    matrix_name_label.grid(row=cur_row, column=0, pady=10, columnspan=3, sticky="W")
    cur_row += 1
    cur_column = 0
    list_submit_edit_matrix_button = []
    for i_matrices_ in range(0, len(matrix)):
        submit_add_matrix_button = tk.Button(states_parameters_frame, image=list_matrices_name_imgs[i_matrices_], command=lambda ind_1=i_matrices_: add_matrix_to_entry_expr_edit_param_button_command(ind_1))
        list_submit_edit_matrix_button.append(submit_add_matrix_button)
        list_submit_edit_matrix_button[i_matrices_].grid(row=cur_row, column=cur_column, padx=10, pady=10, sticky="W")
        cur_column += 1
        if i_matrices_ % 3 == 2:
            cur_row += 1
            cur_column = 0
    edit_parameter_window_label.grid(row=0, column=0, columnspan=2, pady=10)
    # parameter_name_edit_entry.grid(row=1, column=0, padx=3, pady=10)
    parameter_name_edit_label.grid(row=0, column=0, padx=3, pady=10)
    edit_parameter_window_eq_label.grid(row=0, column=1, padx=3, pady=10)
    parameter_expr_edit_entry.grid(row=0, column=2, padx=3, pady=10)
    submit_edit_parameter_button.grid(row=1, column=0, columnspan=3, pady=10)

    entry_edit_parameter_frame.grid(row=1, column=0, pady=10)
    states_parameters_frame.grid(row=1, column=1, rowspan=2, pady=10, padx=10)
    edit_parameter_window.mainloop()

def add_state_to_entry_expr_edit_param_button_command(ind_):
    parameter_expr_edit_entry_text_edit_win.set(parameter_expr_edit_entry_text_edit_win.get() + state[ind_][0])

def add_parameter_to_entry_expr_edit_param_button_command(ind_):
    parameter_expr_edit_entry_text_edit_win.set(parameter_expr_edit_entry_text_edit_win.get() + parameter[ind_][0])

def add_matrix_to_entry_expr_edit_param_button_command(ind_):
    parameter_expr_edit_entry_text_edit_win.set(parameter_expr_edit_entry_text_edit_win.get() + matrix[ind_][0])

def submit_edit_parameter_entry_command(event, ind_):
    edit_parameter(ind_)
    refresh_edit_parameter_main_window(ind_)
    edit_parameter_window.withdraw()

def submit_edit_parameter_button_command(ind_):
    edit_parameter(ind_)
    refresh_edit_parameter_main_window(ind_)
    edit_parameter_window.withdraw()

def refresh_edit_parameter_main_window(ind_):
    global list_parameters_imgs
    global list_parameters_labels
    parameter[ind_][4] = replace_exprs_to_math(parameter[ind_][1])
    list_parameters_imgs[ind_] = get_images_of_parameter_eq([parameter[ind_]])[0]
    list_parameters_labels[ind_] = tk.Label(parameters_frame, image=list_parameters_imgs[ind_])

    parameters_list_label.grid(row=0, column=0)
    for i_parameters_ in range(0, len(list_parameters_labels)):
        list_parameters_labels[i_parameters_].grid(row=i_parameters_ + 1, column=0, sticky="W", pady=10)
        list_parameters_edit_button[i_parameters_].grid(row=i_parameters_ + 1, column=1, sticky="W", padx=0, pady=10)
    new_parameter_button.grid(row=len(list_parameters_labels) + 1, column=0, pady=30)

def open_edit_matrix_window(ind):
    global edit_matrix_window
    print("ind=", ind)
    edit_matrix_window = tk.Toplevel()
    edit_matrix_window.title("Edit matrix")
    edit_matrix_window.geometry("700x500")
    edit_matrix_window_label = tk.Label(edit_matrix_window, text="Edit matrix:", fg="blue", bg="gray", font=("Helvtica", 18))
    entry_edit_matrix_frame = tk.Frame(edit_matrix_window)

    # parameter_name_edit_entry_text = tk.StringVar()
    # global parameter_name_edit_entry
    # parameter_name_edit_entry = tk.Entry(edit_parameter_window, width="5", font=("Helvtica", 16), textvariable=parameter_name_edit_entry_text)
    # parameter_name_edit_entry_text.set(parameter[ind][0])

    matrix_name_edit_label = tk.Label(entry_edit_matrix_frame, image=list_matrices_name_imgs[ind])

    edit_matrix_window_eq_label = tk.Label(entry_edit_matrix_frame, text=" = ", fg="black", font=("Helvtica", 18))

    global list_matrix_expr_edit_entry_text_edit_win
    list_matrix_expr_edit_entry_text_edit_win = []
    for i_ in range(0, int(matrix[ind][5])):
        l_strval = []
        for j_ in range(0, int(matrix[ind][6])):
            l_strval.append(tk.StringVar())
        list_matrix_expr_edit_entry_text_edit_win.append(l_strval)

    global list_matrix_expr_edit_entry
    list_matrix_expr_edit_entry = []
    for i_ in range(0, int(matrix[ind][5])):
        l_strval = []
        for j_ in range(0, int(matrix[ind][6])):
            l_strval.append(tk.Entry(entry_edit_matrix_frame, font=("Helvtica", 16), width="8", textvariable=list_matrix_expr_edit_entry_text_edit_win[i_][j_]))
        list_matrix_expr_edit_entry.append(l_strval)

    for i_ in range(0, int(matrix[ind][5])):
        for j_ in range(0, int(matrix[ind][6])):
            if type(matrix[ind][1]) == list:
                list_matrix_expr_edit_entry_text_edit_win[i_][j_].set(matrix[ind][1][i_][j_])
            list_matrix_expr_edit_entry[i_][j_].bind('<Return>', lambda event, ind_1=ind: submit_edit_matrix_entry_command(event, ind_1))

    submit_edit_matrix_button = tk.Button(entry_edit_matrix_frame, text="Submit", command=lambda ind_1=ind: submit_edit_matrix_button_command(ind_1))

    entry_edit_matrix_expr_frame = tk.Frame(edit_matrix_window)
    edit_matrix_val_window_or_label = tk.Label(entry_edit_matrix_expr_frame, text=" OR ", fg="black", font=("Helvtica", 18))
    matrix_name_label_expr = tk.Label(entry_edit_matrix_expr_frame, image=list_matrices_name_imgs[ind])
    edit_matrix_expr_window_eq_label = tk.Label(entry_edit_matrix_expr_frame, text=" = ", fg="black", font=("Helvtica", 18))
    global matrix_expr_edit_entry_text_edit_win
    matrix_expr_edit_entry_text_edit_win = tk.StringVar()
    global matrix_expr_edit_entry
    matrix_expr_edit_entry = tk.Entry(entry_edit_matrix_expr_frame, font=("Helvtica", 16), textvariable=matrix_expr_edit_entry_text_edit_win)
    if type(matrix[ind][1]) != list:
        matrix_expr_edit_entry_text_edit_win.set(matrix[ind][1])
    submit_edit_matrix_button_expr = tk.Button(entry_edit_matrix_expr_frame, text="Submit", command=lambda ind_1=ind: submit_edit_matrix_expr_button_command(ind_1))

    states_parameters_frame = tk.Frame(edit_matrix_window, borderwidth=1, bd=1, relief=tk.SUNKEN)
    state_name_label = tk.Label(states_parameters_frame, text=" States: ", fg="black", font=("Helvtica", 14))
    state_name_label.grid(row=0, column=0, pady=10, columnspan=3, sticky="W")
    list_submit_edit_state_button = []
    cur_row = 1
    cur_column = 0
    for i_states_ in range(0, len(state)):
        submit_add_state_button = tk.Button(states_parameters_frame, image=list_states_name_imgs[i_states_])
        list_submit_edit_state_button.append(submit_add_state_button)
        list_submit_edit_state_button[i_states_].grid(row=cur_row, column=cur_column, pady=10, sticky="W", padx=10)
        cur_column += 1
        if i_states_ % 3 == 2:
            cur_row += 1
            cur_column = 0
    parameter_name_label = tk.Label(states_parameters_frame, text=" Parameters: ", fg="black", font=("Helvtica", 14))
    cur_row += 1
    parameter_name_label.grid(row=cur_row, column=0, pady=10, columnspan=3, sticky="W")
    cur_row += 1
    cur_column = 0
    list_submit_edit_parameter_button = []
    for i_parameters_ in range(0, len(parameter)):
        submit_add_parameter_button = tk.Button(states_parameters_frame, image=list_parameters_name_imgs[i_parameters_])
        list_submit_edit_parameter_button.append(submit_add_parameter_button)
        list_submit_edit_parameter_button[i_parameters_].grid(row=cur_row, column=cur_column, padx=10, pady=10, sticky="W")
        cur_column += 1
        if i_parameters_ % 3 == 2:
            cur_row += 1
            cur_column = 0
    matrix_name_label = tk.Label(states_parameters_frame, text=" Matrices: ", fg="black", font=("Helvtica", 14))
    cur_row += 1
    matrix_name_label.grid(row=cur_row, column=0, pady=10, columnspan=3, sticky="W")
    cur_row += 1
    cur_column = 0
    list_submit_edit_matrix_button = []
    for i_matrices_ in range(0, len(matrix)):
        submit_add_matrix_button = tk.Button(states_parameters_frame, image=list_matrices_name_imgs[i_matrices_])
        list_submit_edit_matrix_button.append(submit_add_matrix_button)
        list_submit_edit_matrix_button[i_matrices_].grid(row=cur_row, column=cur_column, padx=10, pady=10, sticky="W")
        cur_column += 1
        if i_matrices_ % 3 == 2:
            cur_row += 1
            cur_column = 0

    edit_matrix_window_label.grid(row=0, column=0, columnspan=2, pady=10)
    # parameter_name_edit_entry.grid(row=1, column=0, padx=3, pady=10)
    matrix_name_edit_label.grid(row=0, column=0, padx=3, pady=10)
    edit_matrix_window_eq_label.grid(row=0, column=1, padx=3, pady=10)
    for i_ in range(0, int(matrix[ind][5])):
        for j_ in range(0, int(matrix[ind][6])):
            list_matrix_expr_edit_entry[i_][j_].grid(row=i_, column=2+j_, padx=3, pady=10)
    submit_edit_matrix_button.grid(row=int(matrix[ind][5]), column=0, columnspan=3, pady=10)

    edit_matrix_val_window_or_label.grid(row=0, column=0, pady=10, padx=3)
    matrix_name_label_expr.grid(row=1, column=0, pady=10, padx=3)
    edit_matrix_expr_window_eq_label.grid(row=1, column=1, padx=3, pady=10)
    matrix_expr_edit_entry.grid(row=1, column=2, padx=3, pady=10)
    submit_edit_matrix_button_expr.grid(row=2, column=0, columnspan=3, pady=10)

    entry_edit_matrix_frame.grid(row=1, column=0, pady=10)
    entry_edit_matrix_expr_frame.grid(row=2, column=0, pady=10)
    states_parameters_frame.grid(row=1, column=1, rowspan=3, pady=10, padx=10)
    edit_matrix_window.mainloop()

def edit_state_name():
    global edit_state_name_window
    edit_state_name_window = tk.Toplevel()
    edit_state_name_window.title("Edit state name")
    edit_state_name_window.geometry("300x400")

    global edit_states_name_frame
    edit_states_name_frame = tk.Frame(edit_state_name_window, borderwidth=1, bd=1, relief=tk.SUNKEN)
    states_list_label = tk.Label(edit_states_name_frame, text="States:", font=("Helvtica", 24))
    global list_states_name_edit_labels
    list_states_name_edit_labels = []
    for i_states_name_ in range(0, len(list_states_imgs)):
        list_states_name_edit_labels.append(tk.Label(edit_states_name_frame, image=list_states_name_point_imgs[i_states_name_]))

    list_states_name_edit_button = []
    for i_states_name_ in range(0, len(list_states_imgs)):
        print("i_states_name_=", i_states_name_)
        list_states_name_edit_button.append(tk.Button(edit_states_name_frame, text='Edit', image=edit_icon, compound=tk.LEFT, command=lambda i_states1=i_states_name_: open_edit_state_name_window(i_states1)))
    states_list_label.grid(row=0, column=0)

    for i_states_name_ in range(0, len(list_states_name_edit_labels)):
        list_states_name_edit_labels[i_states_name_].grid(row=i_states_name_ + 1, column=0, sticky="W", pady=10)
        list_states_name_edit_button[i_states_name_].grid(row=i_states_name_ + 1, column=1, sticky="W", padx=30, pady=10)
    edit_states_name_frame.grid(row=0, column=0, padx=20, pady=20, sticky="W")
    edit_state_name_window.mainloop()

def submit_edit_matrix_entry_command(event, ind_):
    edit_matrix(ind_)
    refresh_edit_matrix_main_window(ind_)
    edit_matrix_window.withdraw()

def submit_edit_matrix_button_command(ind_):
    edit_matrix(ind_)
    refresh_edit_matrix_main_window(ind_)
    edit_matrix_window.withdraw()


def submit_edit_matrix_expr_button_command(ind_):
    edit_matrix_expr(ind_)
    refresh_edit_matrix_expr_main_window(ind_)
    edit_matrix_window.withdraw()


def refresh_edit_matrix_main_window(ind_):
    pass

def refresh_edit_matrix_expr_main_window(ind_):
    pass

def open_edit_control_window(ind):
    global edit_control_window
    print("ind=", ind)
    edit_control_window = tk.Toplevel()
    edit_control_window.title("Edit control")
    edit_control_window.geometry("700x500")
    edit_control_window_label = tk.Label(edit_control_window, text="Edit control expression:", fg="blue", bg="gray", font=("Helvtica", 18))
    entry_edit_control_frame = tk.Frame(edit_control_window)
    edit_control_window_eq_label = tk.Label(entry_edit_control_frame, text=" ∈ ", fg="black", font=("Helvtica", 18))
    edit_control_window_bracket_left_label = tk.Label(entry_edit_control_frame, text=" [", fg="black", font=("Helvtica", 18))
    edit_control_window_bracket_comma_label = tk.Label(entry_edit_control_frame, text=", ", fg="black", font=("Helvtica", 18))
    edit_control_window_bracket_right_label = tk.Label(entry_edit_control_frame, text=" ]", fg="black", font=("Helvtica", 18))
    edit_control_window_step_label = tk.Label(entry_edit_control_frame, text=" Step = ", fg="black", font=("Helvtica", 18))
    control_name_edit_label = tk.Label(entry_edit_control_frame, image=list_controls_name_imgs[ind])
    global control_left_inter_entry_text
    control_left_inter_entry_text = tk.StringVar()
    global control_left_inter_edit_entry
    control_left_inter_edit_entry = tk.Entry(entry_edit_control_frame, font=("Helvtica", 16), textvariable=control_left_inter_entry_text, width="5")
    control_left_inter_edit_entry.bind('<Return>', submit_edit_control_entry_command)
    control_left_inter_entry_text.set(control[ind][1][0])
    global control_right_inter_entry_text
    control_right_inter_entry_text = tk.StringVar()
    global control_right_inter_edit_entry
    control_right_inter_edit_entry = tk.Entry(entry_edit_control_frame, font=("Helvtica", 16), textvariable=control_right_inter_entry_text, width="5")
    control_right_inter_edit_entry.bind('<Return>', submit_edit_control_entry_command)
    control_right_inter_entry_text.set(control[ind][1][1])
    global control_step_inter_entry_text
    control_step_inter_entry_text = tk.StringVar()
    global control_step_inter_edit_entry
    control_step_inter_edit_entry = tk.Entry(entry_edit_control_frame, font=("Helvtica", 16), textvariable=control_step_inter_entry_text, width="5")
    control_step_inter_edit_entry.bind('<Return>', submit_edit_control_entry_command)
    control_step_inter_entry_text.set(control[ind][1][2])
    submit_edit_control_button = tk.Button(entry_edit_control_frame, text="Submit", command=submit_edit_control_button_command)
    
    edit_control_window_label.grid(row=0, column=0, columnspan=2, pady=10)
    control_name_edit_label.grid(row=0, column=0, padx=3, pady=10)
    edit_control_window_eq_label.grid(row=0, column=1, padx=3, pady=10)
    edit_control_window_bracket_left_label.grid(row=0, column=2, padx=3, pady=10)
    control_left_inter_edit_entry.grid(row=0, column=3, padx=3, pady=10)
    edit_control_window_bracket_comma_label.grid(row=0, column=4, padx=3, pady=10)
    control_right_inter_edit_entry.grid(row=0, column=5, padx=3, pady=10)
    edit_control_window_bracket_right_label.grid(row=0, column=6, padx=3, pady=10)
    edit_control_window_step_label.grid(row=1, column=0, columnspan=2, pady=10)
    control_step_inter_edit_entry.grid(row=1, column=2, columnspan=3, pady=10)
    submit_edit_control_button.grid(row=2, column=0, columnspan=3, pady=10)

    entry_edit_control_frame.grid(row=1, column=0, pady=10)
    edit_control_window.mainloop()


def submit_edit_control_entry_command(event, ind_):
    edit_control(ind_)
    refresh_edit_control_main_window(ind_)
    edit_control_window.withdraw()

def submit_edit_control_button_command(ind_):
    edit_control(ind_)
    refresh_edit_control_main_window(ind_)
    edit_control_window.withdraw()

def refresh_edit_control_main_window(ind_):
    pass
    
def edit_parameter_name():
    global edit_parameter_name_window
    edit_parameter_name_window = tk.Toplevel()
    edit_parameter_name_window.title("Edit parameter name")
    edit_parameter_name_window.geometry("300x400")

    global edit_parameters_name_frame
    edit_parameters_name_frame = tk.Frame(edit_parameter_name_window, borderwidth=1, bd=1, relief=tk.SUNKEN)
    parameters_list_label = tk.Label(edit_parameters_name_frame, text="parameters:", font=("Helvtica", 24))
    global list_parameters_name_edit_labels
    list_parameters_name_edit_labels = []
    for i_parameters_name_ in range(0, len(list_parameters_imgs)):
        list_parameters_name_edit_labels.append(
            tk.Label(edit_parameters_name_frame, image=list_parameters_name_imgs[i_parameters_name_]))

    list_parameters_name_edit_button = []
    for i_parameters_name_ in range(0, len(list_parameters_imgs)):
        print("i_parameters_name_=", i_parameters_name_)
        list_parameters_name_edit_button.append(
            tk.Button(edit_parameters_name_frame, text='Edit', image=edit_icon, compound=tk.LEFT,
                      command=lambda i_parameters1=i_parameters_name_: open_edit_parameter_name_window(i_parameters1)))
    parameters_list_label.grid(row=0, column=0)

    for i_parameters_name_ in range(0, len(list_parameters_name_edit_labels)):
        list_parameters_name_edit_labels[i_parameters_name_].grid(row=i_parameters_name_ + 1, column=0, sticky="W", pady=10)
        list_parameters_name_edit_button[i_parameters_name_].grid(row=i_parameters_name_ + 1, column=1, sticky="W", padx=30,
                                                          pady=10)
    edit_parameters_name_frame.grid(row=0, column=0, padx=20, pady=20, sticky="W")
    edit_parameter_name_window.mainloop()

def open_edit_parameter_name_window(ind):
    global edit_selected_parameter_name_window
    print("ind=", ind)
    edit_selected_parameter_name_window = tk.Toplevel()
    edit_selected_parameter_name_window.title("Edit selected parameter name")
    edit_selected_parameter_name_window.geometry("300x200")
    edit_selected_parameter_name_window_label = tk.Label(edit_selected_parameter_name_window, text="Edit selected parameter name:", fg="blue", bg="gray", font=("Helvtica", 18))

    parameter_name_edit_entry_text = tk.StringVar()
    global parameter_name_edit_entry
    parameter_name_edit_entry = tk.Entry(edit_selected_parameter_name_window, width="10", font=("Helvtica", 16), textvariable=parameter_name_edit_entry_text)
    parameter_name_edit_entry_text.set(parameter[ind][0])
    parameter_name_edit_entry.bind('<Return>', lambda event, ind_1=ind: submit_edit_selected_parameter_name_entry_command(event, ind_1))

    submit_edit_parameter_button = tk.Button(edit_selected_parameter_name_window, text="Submit", command=lambda ind_1=ind: submit_edit_selected_parameter_name_button_command(ind_1))
    submit_edit_parameter_button.grid(row=2, column=0, columnspan=3, pady=10)
    parameter_name_edit_entry.grid(row=1, column=0, columnspan=3, pady=10)
    edit_selected_parameter_name_window_label.grid(row=0, column=0, columnspan=3, pady=10)
    edit_selected_parameter_name_window.mainloop()
    
def submit_edit_selected_parameter_name_button_command(ind_):
    edit_parameter_name_list(ind_)
    refresh_edit_name_parameter_main_window(ind_)
    edit_selected_parameter_name_window.withdraw()

def submit_edit_selected_parameter_name_entry_command(event_, ind_):
    edit_parameter_name_list(ind_)
    refresh_edit_name_parameter_main_window(ind_)
    edit_selected_parameter_name_window.withdraw()

def edit_parameter_name_list(ind_):
    global parameter
    parameter[ind_][0] = parameter_name_edit_entry.get()

def refresh_edit_name_parameter_main_window(ind_):
    global list_parameters_imgs
    global list_parameters_labels
    global list_parameters_name_imgs
    g_i_p_n_, p_n_ = get_images_of_parameter_name([parameter[ind_]])
    parameter[ind_][3] = p_n_[0]
    list_parameters_name_imgs[ind_] = g_i_p_n_[0]
    parameter[ind_][4] = replace_exprs_to_math(parameter[ind_][1])
    # parameters_list_label.grid(row=0, column=0)
    list_parameters_name_edit_labels = []
    list_parameters_imgs[ind_] = get_images_of_parameter_eq([parameter[ind_]])[0]
    list_parameters_labels[ind_] = tk.Label(parameters_frame, image=list_parameters_imgs[ind_])
    for i_parameters_ in range(0, len(list_parameters_labels)):
        list_parameters_labels[i_parameters_].grid(row=i_parameters_ + 1, column=0, sticky="W", pady=10)
        # list_parameters_edit_button[i_parameters_].grid(row=i_parameters_ + 1, column=1, sticky="W", padx=0, pady=10)
    # new_parameter_button.grid(row=len(list_parameters_labels) + 1, column=0, pady=30)
    for i_parameters_name_ in range(0, len(list_parameters_imgs)):
        list_parameters_name_edit_labels.append(tk.Label(edit_parameters_name_frame, image=list_parameters_name_imgs[i_parameters_name_]))
        list_parameters_name_edit_labels[i_parameters_name_].grid(row=i_parameters_name_ + 1, column=0, sticky="W", pady=10)

def edit_matrix_name():
    global edit_matrix_name_window
    edit_matrix_name_window = tk.Toplevel()
    edit_matrix_name_window.title("Edit matrix name")
    edit_matrix_name_window.geometry("300x400")

    global edit_matrices_name_frame
    edit_matrices_name_frame = tk.Frame(edit_matrix_name_window, borderwidth=1, bd=1, relief=tk.SUNKEN)
    matrices_list_label = tk.Label(edit_matrices_name_frame, text="matrices:", font=("Helvtica", 24))
    global list_matrices_name_edit_labels
    list_matrices_name_edit_labels = []
    for i_matrices_name_ in range(0, len(list_matrices_name_imgs)):
        list_matrices_name_edit_labels.append(
            tk.Label(edit_matrices_name_frame, image=list_matrices_name_imgs[i_matrices_name_]))

    list_matrices_name_edit_button = []
    for i_matrices_name_ in range(0, len(list_matrices_name_imgs)):
        print("i_matrices_name_=", i_matrices_name_)
        list_matrices_name_edit_button.append(
            tk.Button(edit_matrices_name_frame, text='Edit', image=edit_icon, compound=tk.LEFT,
                      command=lambda i_matrices1=i_matrices_name_: open_edit_matrix_name_window(i_matrices1)))
    matrices_list_label.grid(row=0, column=0)

    for i_matrices_name_ in range(0, len(list_matrices_name_edit_labels)):
        list_matrices_name_edit_labels[i_matrices_name_].grid(row=i_matrices_name_ + 1, column=0, sticky="W", pady=10)
        list_matrices_name_edit_button[i_matrices_name_].grid(row=i_matrices_name_ + 1, column=1, sticky="W", padx=30,
                                                          pady=10)
    edit_matrices_name_frame.grid(row=0, column=0, padx=20, pady=20, sticky="W")
    edit_matrix_name_window.mainloop()

def open_edit_matrix_name_window(ind):
    global edit_selected_matrix_name_window
    print("ind=", ind)
    edit_selected_matrix_name_window = tk.Toplevel()
    edit_selected_matrix_name_window.title("Edit selected matrix name")
    edit_selected_matrix_name_window.geometry("300x200")
    edit_selected_matrix_name_window_label = tk.Label(edit_selected_matrix_name_window, text="Edit selected matrix name:", fg="blue", bg="gray", font=("Helvtica", 18))

    matrix_name_edit_entry_text = tk.StringVar()
    global matrix_name_edit_entry
    matrix_name_edit_entry = tk.Entry(edit_selected_matrix_name_window, width="10", font=("Helvtica", 16), textvariable=matrix_name_edit_entry_text)
    matrix_name_edit_entry_text.set(matrix[ind][0])
    matrix_name_edit_entry.bind('<Return>', lambda event, ind_1=ind: submit_edit_selected_matrix_name_entry_command(event, ind_1))

    submit_edit_matrix_button = tk.Button(edit_selected_matrix_name_window, text="Submit", command=lambda ind_1=ind: submit_edit_selected_matrix_name_button_command(ind_1))
    submit_edit_matrix_button.grid(row=2, column=0, columnspan=3, pady=10)
    matrix_name_edit_entry.grid(row=1, column=0, columnspan=3, pady=10)
    edit_selected_matrix_name_window_label.grid(row=0, column=0, columnspan=3, pady=10)
    edit_selected_matrix_name_window.mainloop()

def submit_edit_selected_matrix_name_button_command(ind_):
    edit_matrix_name_list(ind_)
    refresh_edit_name_matrix_main_window(ind_)
    edit_selected_matrix_name_window.withdraw()

def submit_edit_selected_matrix_name_entry_command(event_, ind_):
    edit_matrix_name_list(ind_)
    refresh_edit_name_matrix_main_window(ind_)
    edit_selected_matrix_name_window.withdraw()

def edit_matrix_name_list(ind_):
    global matrix
    matrix[ind_][0] = matrix_name_edit_entry.get()

def refresh_edit_name_matrix_main_window(ind_):
    # global list_matrices_imgs
    global list_matrices_labels
    global list_matrices_name_imgs
    g_i_p_n_, p_n_ = get_images_of_matrix_name([matrix[ind_]])
    matrix[ind_][3] = p_n_[0]
    list_matrices_name_imgs[ind_] = g_i_p_n_[0]
    matrix[ind_][4] = replace_exprs_to_math(matrix[ind_][1])
    # matrices_list_label.grid(row=0, column=0)
    list_matrices_name_edit_labels = []
    # list_matrices_imgs[ind_] = get_images_of_matrix_eq([matrix[ind_]])[0]
    list_matrices_labels[ind_] = tk.Label(matrices_frame, image=list_matrices_name_imgs[ind_])
    for i_matrices_ in range(0, len(list_matrices_labels)):
        list_matrices_labels[i_matrices_].grid(row=i_matrices_ + 1, column=0, sticky="W", pady=10)
        # list_matrices_edit_button[i_matrices_].grid(row=i_matrices_ + 1, column=1, sticky="W", padx=0, pady=10)
    # new_matrix_button.grid(row=len(list_matrices_labels) + 1, column=0, pady=30)
    for i_matrices_name_ in range(0, len(list_matrices_name_imgs)):
        list_matrices_name_edit_labels.append(tk.Label(edit_matrices_name_frame, image=list_matrices_name_imgs[i_matrices_name_]))
        list_matrices_name_edit_labels[i_matrices_name_].grid(row=i_matrices_name_ + 1, column=0, sticky="W", pady=10)
        
def open_edit_state_name_window(ind):
    global edit_selected_state_name_window
    print("ind=", ind)
    edit_selected_state_name_window = tk.Toplevel()
    edit_selected_state_name_window.title("Edit selected state name")
    edit_selected_state_name_window.geometry("300x200")
    edit_selected_state_name_window_label = tk.Label(edit_selected_state_name_window, text="Edit selected state name:", fg="blue", bg="gray", font=("Helvtica", 18))

    state_name_edit_entry_text = tk.StringVar()
    global state_name_edit_entry
    state_name_edit_entry = tk.Entry(edit_selected_state_name_window, width="10", font=("Helvtica", 16), textvariable=state_name_edit_entry_text)
    state_name_edit_entry_text.set(state[ind][0])
    state_name_edit_entry.bind('<Return>', lambda event, ind_1=ind: submit_edit_selected_state_name_entry_command(event, ind_1))

    submit_edit_state_button = tk.Button(edit_selected_state_name_window, text="Submit", command=lambda ind_1=ind: submit_edit_selected_state_name_button_command(ind_1))
    submit_edit_state_button.grid(row=2, column=0, columnspan=3, pady=10)
    state_name_edit_entry.grid(row=1, column=0, columnspan=3, pady=10)
    edit_selected_state_name_window_label.grid(row=0, column=0, columnspan=3, pady=10)
    edit_selected_state_name_window.mainloop()

def submit_edit_selected_state_name_button_command(ind_):
    edit_state_name_list(ind_)
    refresh_edit_name_state_main_window(ind_)
    edit_selected_state_name_window.withdraw()

def submit_edit_selected_state_name_entry_command(event_, ind_):
    edit_state_name_list(ind_)
    refresh_edit_name_state_main_window(ind_)
    edit_selected_state_name_window.withdraw()

def edit_state_name_list(ind_):
    global state
    state[ind_][0] = state_name_edit_entry.get()

def refresh_edit_name_state_main_window(ind_):
    global list_states_imgs
    global list_states_labels
    global list_states_name_point_imgs
    global list_states_name_imgs

    list_states_labels[ind_] = tk.Label(states_frame, image=list_states_imgs[ind_])
    g_i_s_n_, l_s_n = get_images_of_state_name([state[ind_]])
    state[ind_][3] = l_s_n[0]
    list_states_name_imgs[ind_] = g_i_s_n_[0]
    list_states_name_point_imgs[ind_] = get_images_of_state_name_point([state[ind_]])[0]
    state[ind_][4] = replace_exprs_to_math(state[ind_][1])
    list_states_imgs[ind_] = get_images_of_state_eq([state[ind_]])[0]
    # states_list_label.grid(row=0, column=0)
    list_states_name_edit_labels = []
    for i_states_ in range(0, len(list_states_labels)):
        list_states_labels[i_states_].grid(row=i_states_ + 1, column=0, sticky="W", pady=10)
        # list_states_edit_button[i_states_].grid(row=i_states_ + 1, column=1, sticky="W", padx=0, pady=10)
    # new_state_button.grid(row=len(list_states_labels) + 1, column=0, pady=30)
    for i_states_name_ in range(0, len(list_states_imgs)):
        list_states_name_edit_labels.append(tk.Label(edit_states_name_frame, image=list_states_name_point_imgs[i_states_name_]))
        list_states_name_edit_labels[i_states_name_].grid(row=i_states_name_ + 1, column=0, sticky="W", pady=10)


def edit_control_name():
    global edit_control_name_window
    edit_control_name_window = tk.Toplevel()
    edit_control_name_window.title("Edit control name")
    edit_control_name_window.geometry("300x400")

    global edit_controls_name_frame
    edit_controls_name_frame = tk.Frame(edit_control_name_window, borderwidth=1, bd=1, relief=tk.SUNKEN)
    controls_list_label = tk.Label(edit_controls_name_frame, text="controls:", font=("Helvtica", 24))
    global list_controls_name_edit_labels
    list_controls_name_edit_labels = []
    for i_controls_name_ in range(0, len(list_controls_name_imgs)):
        list_controls_name_edit_labels.append(
            tk.Label(edit_controls_name_frame, image=list_controls_name_imgs[i_controls_name_]))

    list_controls_name_edit_button = []
    for i_controls_name_ in range(0, len(list_controls_name_imgs)):
        print("i_controls_name_=", i_controls_name_)
        list_controls_name_edit_button.append(
            tk.Button(edit_controls_name_frame, text='Edit', image=edit_icon, compound=tk.LEFT,
                      command=lambda i_controls1=i_controls_name_: open_edit_control_name_window(i_controls1)))
    controls_list_label.grid(row=0, column=0)

    for i_controls_name_ in range(0, len(list_controls_name_edit_labels)):
        list_controls_name_edit_labels[i_controls_name_].grid(row=i_controls_name_ + 1, column=0, sticky="W", pady=10)
        list_controls_name_edit_button[i_controls_name_].grid(row=i_controls_name_ + 1, column=1, sticky="W", padx=30, pady=10)
    edit_controls_name_frame.grid(row=0, column=0, padx=20, pady=20, sticky="W")
    edit_control_name_window.mainloop()


def open_edit_control_name_window(ind):
    global edit_selected_control_name_window
    print("ind=", ind)
    edit_selected_control_name_window = tk.Toplevel()
    edit_selected_control_name_window.title("Edit selected control name")
    edit_selected_control_name_window.geometry("300x200")
    edit_selected_control_name_window_label = tk.Label(edit_selected_control_name_window,
                                                         text="Edit selected control name:", fg="blue", bg="gray",
                                                         font=("Helvtica", 18))

    control_name_edit_entry_text = tk.StringVar()
    global control_name_edit_entry
    control_name_edit_entry = tk.Entry(edit_selected_control_name_window, width="10", font=("Helvtica", 16),
                                         textvariable=control_name_edit_entry_text)
    control_name_edit_entry_text.set(control[ind][0])
    control_name_edit_entry.bind('<Return>',
                                   lambda event, ind_1=ind: submit_edit_selected_control_name_entry_command(event,
                                                                                                              ind_1))

    submit_edit_control_button = tk.Button(edit_selected_control_name_window, text="Submit", command=lambda
        ind_1=ind: submit_edit_selected_control_name_button_command(ind_1))
    submit_edit_control_button.grid(row=2, column=0, columnspan=3, pady=10)
    control_name_edit_entry.grid(row=1, column=0, columnspan=3, pady=10)
    edit_selected_control_name_window_label.grid(row=0, column=0, columnspan=3, pady=10)
    edit_selected_control_name_window.mainloop()


def submit_edit_selected_control_name_button_command(ind_):
    edit_control_name_list(ind_)
    refresh_edit_name_control_main_window(ind_)
    edit_selected_control_name_window.withdraw()


def submit_edit_selected_control_name_entry_command(event_, ind_):
    edit_control_name_list(ind_)
    refresh_edit_name_control_main_window(ind_)
    edit_selected_control_name_window.withdraw()


def edit_control_name_list(ind_):
    global control
    control[ind_][0] = control_name_edit_entry.get()


def refresh_edit_name_control_main_window(ind_):
    global list_controls_labels
    global list_controls_name_imgs
    g_i_p_n_, p_n_ = get_images_of_control_name([control[ind_]])
    control[ind_][3] = p_n_[0]
    list_controls_name_imgs[ind_] = g_i_p_n_[0]
    # controls_list_label.grid(row=0, column=0)
    list_controls_name_edit_labels = []
    list_controls_labels[ind_] = tk.Label(controls_frame, image=list_controls_name_imgs[ind_])
    for i_controls_ in range(0, len(list_controls_labels)):
        list_controls_labels[i_controls_].grid(row=i_controls_ + 1, column=0, sticky="W", pady=10)
        # list_controls_edit_button[i_controls_].grid(row=i_controls_ + 1, column=1, sticky="W", padx=0, pady=10)
    # new_control_button.grid(row=len(list_controls_labels) + 1, column=0, pady=30)
    for i_controls_name_ in range(0, len(list_controls_name_imgs)):
        list_controls_name_edit_labels.append(tk.Label(edit_controls_name_frame, image=list_controls_name_imgs[i_controls_name_]))
        list_controls_name_edit_labels[i_controls_name_].grid(row=i_controls_name_ + 1, column=0, sticky="W", pady=10)

def open_guard_reset_window():
    global guard_reset_window
    guard_reset_window = tk.Toplevel()
    guard_reset_window.title("Define guard and reset")
    guard_reset_window.geometry("700x500")
    guard_reset_window_label = tk.Label(guard_reset_window, text="Define a guard and a reset:", fg="blue", bg="gray", font=("Helvtica", 18))
    guard_reset_frame = tk.Frame(guard_reset_window)

    guard_frame = tk.Frame(guard_reset_frame)
    guard_label = tk.Label(guard_frame, text=" Guard = ", fg="black", font=("Helvtica", 14))
    global guard_value_entry_text
    guard_value_entry_text = tk.StringVar()
    global guard_value_entry
    guard_value_entry = tk.Entry(guard_frame, width="10", font=("Helvtica", 16), textvariable=guard_value_entry_text)
    if guard:
        guard_value_entry_text.set(guard[0])
    # guard_value_entry.bind('<Return>', lambda event, ind_1=ind: submit_guard_reset_entry_command(event, ind_1))
    guard_label.grid(row=0, column=0, pady=10)
    guard_value_entry.grid(row=0, column=1, pady=10)
    guard_frame.grid(row=0, column=0, pady=10)

    reset_frame = tk.Frame(guard_reset_frame)
    reset_label = tk.Label(reset_frame, text=" Reset: ", fg="black", font=("Helvtica", 14))
    list_reset_state_label = []
    global list_reset_state_value_entry_text
    global list_reset_state_value_entry
    list_reset_state_value_entry_text = []
    list_reset_state_value_entry = []
    for i_states_ in range(0, len(state)):
        list_reset_state_label.append(tk.Label(reset_frame, image=list_states_name_imgs[i_states_]))
        list_reset_state_value_entry_text.append(tk.StringVar())
        list_reset_state_value_entry.append(tk.Entry(reset_frame, width="10", font=("Helvtica", 16), textvariable=list_reset_state_value_entry_text[i_states_]))
        if reset:
            list_reset_state_value_entry_text[i_states_].set(reset[0][i_states_])
    reset_label.grid(row=0, column=0, pady=10)
    for i_states_ in range(0, len(state)):
        list_reset_state_label[i_states_].grid(row=i_states_+1, column=0, pady=10)
        list_reset_state_value_entry[i_states_].grid(row=i_states_+1, column=1, pady=10)
    reset_frame.grid(row=1, column=0, pady=10)

    submit_guard_reset_button = tk.Button(guard_reset_frame, text="Submit", command=submit_guard_reset_button_command)
    submit_guard_reset_button.grid(row=2, column=0, pady=10)
    # submit_edit_state_button.grid(row=2, column=0, columnspan=3, pady=10)
    # state_name_edit_entry.grid(row=1, column=0, columnspan=3, pady=10)

    states_parameters_frame = tk.Frame(guard_reset_window, borderwidth=1, bd=1, relief=tk.SUNKEN)
    state_name_label = tk.Label(states_parameters_frame, text=" States: ", fg="black", font=("Helvtica", 14))
    state_name_label.grid(row=0, column=0, pady=10, columnspan=3, sticky="W")
    list_submit_edit_state_button = []
    cur_row = 1
    cur_column = 0
    for i_states_ in range(0, len(state)):
        submit_add_state_button = tk.Button(states_parameters_frame, image=list_states_name_imgs[i_states_])
        list_submit_edit_state_button.append(submit_add_state_button)
        list_submit_edit_state_button[i_states_].grid(row=cur_row, column=cur_column, pady=10, sticky="W", padx=10)
        cur_column += 1
        if i_states_ % 3 == 2:
            cur_row += 1
            cur_column = 0
    parameter_name_label = tk.Label(states_parameters_frame, text=" Parameters: ", fg="black", font=("Helvtica", 14))
    cur_row += 1
    parameter_name_label.grid(row=cur_row, column=0, pady=10, columnspan=3, sticky="W")
    cur_row += 1
    cur_column = 0
    list_submit_edit_parameter_button = []
    for i_parameters_ in range(0, len(parameter)):
        submit_add_parameter_button = tk.Button(states_parameters_frame, image=list_parameters_name_imgs[i_parameters_])
        list_submit_edit_parameter_button.append(submit_add_parameter_button)
        list_submit_edit_parameter_button[i_parameters_].grid(row=cur_row, column=cur_column, padx=10, pady=10, sticky="W")
        cur_column += 1
        if i_parameters_ % 3 == 2:
            cur_row += 1
            cur_column = 0
    matrix_name_label = tk.Label(states_parameters_frame, text=" Matrices: ", fg="black", font=("Helvtica", 14))
    cur_row += 1
    matrix_name_label.grid(row=cur_row, column=0, pady=10, columnspan=3, sticky="W")
    cur_row += 1
    cur_column = 0
    list_submit_edit_matrix_button = []
    for i_matrices_ in range(0, len(matrix)):
        submit_add_matrix_button = tk.Button(states_parameters_frame, image=list_matrices_name_imgs[i_matrices_])
        list_submit_edit_matrix_button.append(submit_add_matrix_button)
        list_submit_edit_matrix_button[i_matrices_].grid(row=cur_row, column=cur_column, padx=10, pady=10, sticky="W")
        cur_column += 1
        if i_matrices_ % 3 == 2:
            cur_row += 1
            cur_column = 0

    guard_reset_window_label.grid(row=0, column=0,  pady=10)
    guard_reset_frame.grid(row=1, column=0, pady=10)
    states_parameters_frame.grid(row=1, column=1, rowspan=3, pady=10, padx=10)
    guard_reset_window.mainloop()


def submit_guard_reset_button_command():
    global guard
    global reset
    guard = [guard_value_entry.get()]
    l_reset_1 = []
    for i_states_ in range(0, len(state)):
        l_reset_1.append(list_reset_state_value_entry[i_states_].get())
    reset = [l_reset_1]
    print("guard=", guard)
    print("reset=", reset)
    guard_reset_window.withdraw()


def open_configuration_window():
    global configuration_window
    configuration_window = tk.Toplevel()
    configuration_window.title("Configuration")
    configuration_window.geometry("600x500")
    configuration_window_label = tk.Label(configuration_window, text="Set the configuration of the system:", fg="blue", bg="gray", font=("Helvtica", 18))
    dt_label = tk.Label(configuration_window, text="dt =", font=("Helvtica", 10))
    epsilon_label = tk.Label(configuration_window, text="Initial gap epsilon =", font=("Helvtica", 10))
    w_label = tk.Label(configuration_window, text="Perturbation w =", font=("Helvtica", 10))
    number_periods_label = tk.Label(configuration_window, text="number of periods =", font=("Helvtica", 10))
    one_period_value_label = tk.Label(configuration_window, text="One period value:", font=("Helvtica", 10))
    global dt_entry
    dt_entry_text = tk.StringVar()
    dt_entry = tk.Entry(configuration_window, width="10", font=("Helvtica", 16), textvariable=dt_entry_text)
    dt_entry.bind('<Return>',  submit_configuration_entry_command)
    dt_entry_text.set(dt)
    global w_entry
    w_entry_text = tk.StringVar()
    w_entry = tk.Entry(configuration_window, width="10", font=("Helvtica", 16), textvariable=w_entry_text)
    w_entry.bind('<Return>', submit_configuration_entry_command)
    w_entry_text.set(w)
    global epsilon_entry
    epsilon_entry_text = tk.StringVar()
    epsilon_entry = tk.Entry(configuration_window, width="10", font=("Helvtica", 16), textvariable=epsilon_entry_text)
    epsilon_entry.bind('<Return>', submit_configuration_entry_command)
    epsilon_entry_text.set(epsilon)
    global number_periods_entry
    number_periods_entry_text = tk.StringVar()
    number_periods_entry = tk.Entry(configuration_window, width="10", font=("Helvtica", 16), textvariable=number_periods_entry_text)
    number_periods_entry.bind('<Return>', submit_configuration_entry_command)
    number_periods_entry_text.set(number_periods)
    global period_choice
    period_choice = tk.IntVar()
    period_choice_button1 = tk.Radiobutton(configuration_window, text="Automatically", variable=period_choice, value=1)
    period_choice_button2 = tk.Radiobutton(configuration_window, text="Fixed:", variable=period_choice, value=2)
    global period_fixed_value_entry
    period_fixed_value_entry_text = tk.StringVar()
    period_fixed_value_entry = tk.Entry(configuration_window, width="10", font=("Helvtica", 12), textvariable=period_fixed_value_entry_text)
    period_fixed_value_entry.bind('<Return>', submit_configuration_entry_command)
    period_fixed_value_entry_text.set(one_period_fixed)

    initial_conditions_frame = tk.Frame(configuration_window)
    initial_conditions_label = tk.Label(initial_conditions_frame, text="The initial conditions (at t=0) of the system:", font=("Helvtica", 14))
    initial_conditions_label.grid(row=0, column=0, columnspan=3, pady=10)
    list_init_system_labels = []
    global list_init_system_entry
    list_init_system_entry = []
    list_label_equal = []
    for i_init_ in range(0, len(state)):
        list_init_system_labels.append(tk.Label(initial_conditions_frame, image=list_states_name_imgs[i_init_]))
        init_system_entry_text = tk.StringVar()
        list_label_equal.append(tk.Label(initial_conditions_frame, text=" = "))
        init_system_entry = tk.Entry(initial_conditions_frame, width="10", font=("Helvtica", 16), textvariable=init_system_entry_text)
        init_system_entry.bind('<Return>', submit_configuration_entry_command)
        init_system_entry_text.set(state[i_init_][2])
        list_init_system_entry.append(init_system_entry)
        list_label_equal[i_init_].grid(row=i_init_+1, column=1, pady=10)
        list_init_system_labels[i_init_].grid(row=i_init_+1, column=0, pady=10)
        list_init_system_entry[i_init_].grid(row=i_init_+1, column=2, pady=10)

    submit_configuration_button = tk.Button(configuration_window, text="Submit", command=submit_configuration_button_command)

    configuration_window_label.grid(row=0, column=0, columnspan=3, pady=10)
    dt_label.grid(row=1, column=0, pady=10)
    dt_entry.grid(row=1, column=1, pady=10)
    epsilon_label.grid(row=2, column=0, pady=10)
    epsilon_entry.grid(row=2, column=1, pady=10)
    w_label.grid(row=3, column=0, pady=10)
    w_entry.grid(row=3, column=1, pady=10)
    number_periods_label.grid(row=4, column=0, pady=10)
    number_periods_entry.grid(row=4, column=1, pady=10)
    one_period_value_label.grid(row=5, column=0, rowspan=2)
    period_choice_button1.grid(row=5, column=1, pady=1, sticky="W")
    period_choice_button2.grid(row=6, column=1, pady=1, sticky="W")
    period_fixed_value_entry.grid(row=6, column=2, pady=10, sticky="W")
    initial_conditions_frame.grid(row=7, column=0, columnspan=3, pady=10)

    submit_configuration_button.grid(row=8, column=0, columnspan=3, pady=10)

    configuration_window.mainloop()

def submit_configuration_entry_command(event):
    global w
    global dt
    global epsilon
    global number_periods
    global one_period_fixed
    dt = float(dt_entry.get())
    w = float(w_entry.get())
    epsilon = float(epsilon_entry.get())
    number_periods = int(number_periods_entry.get())
    for i_init_ in range(0, len(state)):
        state[i_init_][2] = list_init_system_entry[i_init_].get()
    if period_choice.get() == 2:
        print("HI")
        one_period_fixed = period_fixed_value_entry.get()
    configuration_window.withdraw()

def submit_configuration_button_command():
    global w
    global dt
    global epsilon
    global number_periods
    global one_period_fixed
    dt = float(dt_entry.get())
    w = float(w_entry.get())
    epsilon = float(epsilon_entry.get())
    number_periods = int(number_periods_entry.get())
    for i_init_ in range(0, len(state)):
        state[i_init_][2] = list_init_system_entry[i_init_].get()
    if period_choice.get() == 2:
        print("HI")
        one_period_fixed = period_fixed_value_entry.get()
    print("dt=", dt)
    print("w=", w)
    print("epsilon=", epsilon)
    print("state=", state)
    configuration_window.withdraw()

def open_display_setting_window():
    global display_setting_window
    display_setting_window = tk.Toplevel()
    display_setting_window.title("Display setting")
    display_setting_window.geometry("700x700")
    display_setting_window_label = tk.Label(display_setting_window, text="Set the display setting:", fg="blue", bg="gray", font=("Helvtica", 20))
    display_states_1D_frame = tk.Frame(display_setting_window)
    list_check_box_state = []
    global list_check_box_state_value
    list_check_box_state_value = []
    state_t_label = tk.Label(display_states_1D_frame, text="Select states to show as a function of t:", font=("Helvtica", 10))
    for i_states_ in range(0, len(state)):
        check_box_state_value_ = tk.StringVar()
        check_box_state_ = tk.Checkbutton(display_states_1D_frame, image=list_states_name_imgs[i_states_], variable=check_box_state_value_, onvalue="show", offvalue="hide")
        check_box_state_.deselect()
        list_check_box_state.append(check_box_state_)
        list_check_box_state[i_states_].grid(row=i_states_, column=1, pady=10)
        list_check_box_state_value.append(check_box_state_value_)
    state_t_label.grid(row=0, column=0, pady=10)

    display_states_2D_frame = tk.Frame(display_setting_window)
    global list_state_name
    list_state_name = []
    for i_states_ in range(0, len(state)):
        list_state_name.append(state[i_states_][0])
    global list_check_box_2d_state_value
    list_check_box_2d_state_value = []
    if len(state) > 1:
        state_2d_label = tk.Label(display_states_2D_frame, text="Select two states to show in 2D plot:", font=("Helvtica", 10))
        state_2d_label.grid(row=0, column=0, pady=10)
        state1_2d_combobox = tkk.Combobox(display_states_2D_frame, value=list_state_name)
        list_check_box_2d_state_value.append(state1_2d_combobox)
        state1_2d_combobox.grid(row=0, column=1, pady=10, padx=5)
        state2_2d_combobox = tkk.Combobox(display_states_2D_frame, value=list_state_name)
        list_check_box_2d_state_value.append(state2_2d_combobox)
        state2_2d_combobox.grid(row=0, column=2, pady=10)

    display_states_3D_frame = tk.Frame(display_setting_window)
    global list_check_box_3d_state_value
    list_check_box_3d_state_value = []
    if len(state) > 2:
        state_3d_label = tk.Label(display_states_3D_frame, text="Select three states to show in 3D plot:", font=("Helvtica", 10))
        state_3d_label.grid(row=0, column=0, pady=10)
        state1_3d_combobox = tkk.Combobox(display_states_3D_frame, value=list_state_name)
        list_check_box_3d_state_value.append(state1_3d_combobox)
        state1_3d_combobox.grid(row=0, column=1, pady=10, padx=5)
        state2_3d_combobox = tkk.Combobox(display_states_3D_frame, value=list_state_name)
        list_check_box_3d_state_value.append(state2_3d_combobox)
        state2_3d_combobox.grid(row=0, column=2, pady=10, padx=5)
        state3_3d_combobox = tkk.Combobox(display_states_3D_frame, value=list_state_name)
        list_check_box_3d_state_value.append(state3_3d_combobox)
        state3_3d_combobox.grid(row=0, column=3, pady=10, padx=5)

    display_func_frame = tk.Frame(display_setting_window)
    global list_check_box_funcs
    list_check_box_funcs = []
    check_box_lambda_value_ = tk.StringVar()
    check_box_delta_value_ = tk.StringVar()
    check_box_gamma_value_ = tk.StringVar()
    display_func_label = tk.Label(display_func_frame, text="Select functions to show:", font=("Helvtica", 10))
    check_box_lambda = tk.Checkbutton(display_func_frame, text="lambda", variable=check_box_lambda_value_, onvalue="show", offvalue="hide")
    check_box_lambda.deselect()
    check_box_delta = tk.Checkbutton(display_func_frame, text="delta", variable=check_box_delta_value_, onvalue="show", offvalue="hide")
    check_box_delta.deselect()
    check_box_gamma = tk.Checkbutton(display_func_frame, text="gamma", variable=check_box_gamma_value_, onvalue="show", offvalue="hide")
    check_box_gamma.deselect()
    list_check_box_funcs.append(check_box_lambda_value_)
    list_check_box_funcs.append(check_box_delta_value_)
    list_check_box_funcs.append(check_box_gamma_value_)
    display_func_label.grid(row=0, column=0, pady=1)
    check_box_lambda.grid(row=0, column=1, pady=1, sticky="W")
    check_box_delta.grid(row=1, column=1, pady=1, sticky="W")
    check_box_gamma.grid(row=2, column=1, pady=1, sticky="W")

    display_options_frame = tk.Frame(display_setting_window)
    global list_check_box_options
    list_check_box_options = []
    check_box_option1_value_ = tk.StringVar()
    check_box_option2_value_ = tk.StringVar()
    check_box_option3_value_ = tk.StringVar()
    display_options_label = tk.Label(display_options_frame, text="Select options:", font=("Helvtica", 10))
    check_box_option1 = tk.Checkbutton(display_options_frame, text="Show the curve of delta", variable=check_box_option1_value_, onvalue="show", offvalue="hide")
    check_box_option1.deselect()
    check_box_option2 = tk.Checkbutton(display_options_frame, text="Color the curves according to the sign of lambda", variable=check_box_option2_value_, onvalue="show", offvalue="hide")
    check_box_option2.deselect()
    check_box_option3 = tk.Checkbutton(display_options_frame, text="Show simulations", variable=check_box_option3_value_, onvalue="show", offvalue="hide")
    check_box_option3.deselect()
    list_check_box_options.append(check_box_option1_value_)
    list_check_box_options.append(check_box_option2_value_)
    list_check_box_options.append(check_box_option3_value_)
    display_options_label.grid(row=0, column=0, pady=1)
    check_box_option1.grid(row=0, column=1, pady=1, sticky="W")
    check_box_option2.grid(row=1, column=1, pady=1, sticky="W")
    check_box_option3.grid(row=2, column=1, pady=1, sticky="W")

    step_plot_label = tk.Label(display_setting_window, text="Step plot value:", font=("Helvtica", 10))
    global plot_step_entry
    plot_step_entry_text = tk.StringVar()
    plot_step_entry = tk.Entry(display_setting_window, width="10", font=("Helvtica", 12), textvariable=plot_step_entry_text)
    plot_step_entry.bind('<Return>', submit_display_setting_entry_command)
    plot_step_entry_text.set(step_plot)

    submit_display_setting_button = tk.Button(display_setting_window, text="Submit", command=submit_display_setting_button_command)

    display_setting_window_label.grid(row=0, column=0, columnspan=2, pady=10)
    step_plot_label.grid(row=1, column=0, pady=10, sticky="W")
    plot_step_entry.grid(row=1, column=1, pady=10, sticky="W")
    display_states_1D_frame.grid(row=2, column=0, columnspan=2, pady=10, sticky="W")
    display_states_2D_frame.grid(row=3, column=0, columnspan=2, pady=10, sticky="W")
    display_states_3D_frame.grid(row=4, column=0, columnspan=2, pady=10, sticky="W")
    display_func_frame.grid(row=5, column=0, columnspan=2, pady=10, sticky="W")
    display_options_frame.grid(row=6, column=0, columnspan=2, pady=10, sticky="W")
    submit_display_setting_button.grid(row=7, column=0, columnspan=2, pady=10)

    step_plot_label.grid()
    display_setting_window.mainloop()

def submit_display_setting_entry_command(event_):
    global step_plot
    global selected_1d_plot
    global selected_2d_plot
    global selected_3d_plot
    global selected_funcs_plot
    global selected_options_plot
    step_plot = int(plot_step_entry.get())
    selected_1d_plot = []
    selected_2d_plot = []
    selected_3d_plot = []
    selected_funcs_plot = []
    selected_options_plot = []
    for i_l in range(0, len(list_check_box_state_value)):
        selected_1d_plot.append(list_check_box_state_value[i_l].get())
    for i_l in range(0, len(list_check_box_2d_state_value)):
        selected_2d_plot.append(state.index(list_check_box_2d_state_value[i_l].get()))
    for i_l in range(0, len(list_check_box_3d_state_value)):
        selected_3d_plot.append(state.index(list_check_box_3d_state_value[i_l].get()))
    for i_l in range(0, len(list_check_box_funcs)):
        selected_funcs_plot.append(list_check_box_funcs[i_l].get())
    for i_l in range(0, len(list_check_box_options)):
        selected_options_plot.append(list_check_box_options[i_l].get())
    display_setting_window.withdraw()
    print("step_plot=", step_plot)
    print("selected_1d_plot=", selected_1d_plot)
    print("selected_2d_plot=", selected_2d_plot)
    print("selected_3d_plot=", selected_3d_plot)
    print("selected_funcs_plot=", selected_funcs_plot)
    print("selected_options_plot=", selected_options_plot)


def submit_display_setting_button_command():
    global step_plot
    global selected_1d_plot
    global selected_2d_plot
    global selected_3d_plot
    global selected_funcs_plot
    global selected_options_plot
    step_plot = int(plot_step_entry.get())
    selected_1d_plot = []
    selected_2d_plot = []
    selected_3d_plot = []
    selected_funcs_plot = []
    selected_options_plot = []
    for i_l in range(0, len(list_check_box_state_value)):
        selected_1d_plot.append(list_check_box_state_value[i_l].get())
    for i_l in range(0, len(list_check_box_2d_state_value)):
        if list_check_box_2d_state_value[i_l].get() != '':
            selected_2d_plot.append(list_state_name.index(list_check_box_2d_state_value[i_l].get()))
        else:
            selected_2d_plot.append("")
    for i_l in range(0, len(list_check_box_3d_state_value)):
        if list_check_box_3d_state_value[i_l].get() != '':
            selected_3d_plot.append(list_state_name.index(list_check_box_3d_state_value[i_l].get()))
        else:
            selected_3d_plot.append("")
    for i_l in range(0, len(list_check_box_funcs)):
        selected_funcs_plot.append(list_check_box_funcs[i_l].get())
    for i_l in range(0, len(list_check_box_options)):
        selected_options_plot.append(list_check_box_options[i_l].get())
    display_setting_window.withdraw()
    print("step_plot=", step_plot)
    print("selected_1d_plot=", selected_1d_plot)
    print("selected_2d_plot=", selected_2d_plot)
    print("selected_3d_plot=", selected_3d_plot)
    print("selected_funcs_plot=", selected_funcs_plot)
    print("selected_options_plot=", selected_options_plot)

def config_control():
    config_control_window = tk.Toplevel()
    config_control_window.title("config_control")
    config_control_window.geometry("700x700")

    config_control_window.mainloop()

def open_run_window():
    results_window = tk.Toplevel()
    results_window.title("Results")
    results_window.geometry("700x700")
    global tabControl
    tabControl = ttk.Notebook(results_window)
    launch_analysis()
    # tab1 = tkk.Frame(tabControl)
    # tabControl.add(tab1, text='Tab 1')
    tabControl.pack(expand=1, fill='both')
    results_window.mainloop()

def launch_analysis():
    global states_symb
    system_equations_symb, states_symb, l_guard, l_reset = system_eq_symb()
    global states_name
    states_name = funcs.get_states_name_string(states_symb)
    print("states_name=", states_name)
    system_equations = funcs.system_eq_func(system_equations_symb, states_symb)
    guard_equations = funcs.system_eq_func(l_guard, states_symb)
    reset_equations = funcs.system_eq_func(l_reset, states_symb)
    length_system = len(system_equations_symb)
    jacob_matrix_sys = funcs.Jacobian_matrix(system_equations_symb, states_symb)
    init_system = []
    for i_states_ in range(0, len(state)):
        init_system.append(float(state[i_states_][2]))
    print("init_system=", init_system)
    if period_choice.get() == 1:
        fp = funcs.find_period(init_system, 6, system_equations, dt, guard_equations, reset_equations)
        i_one_period = fp[0]
        one_period = i_one_period * dt
    else:
        one_period = float(one_period_fixed)
        i_one_period = int(one_period / dt)
    # init_system = fp[1]
    print("i_one_period=", i_one_period)
    print("one period= ", one_period)
    timeEnd = number_periods * one_period
    NodeT = (i_one_period * number_periods) + 1
    print("NodeT= ", NodeT)
    num_system_simu = 2
    period_inclus = 0
    index_fig = 1
    tf = timeEnd
    system_orig = list(np.zeros((NodeT, length_system)))
    # system_top_black = zeros((NodeT, length_system))
    # system_bottom_black = zeros((NodeT, length_system))
    system_orig[0] = init_system
    # system_top_black[0] = init_system
    # system_bottom_black[0] = init_system
    # system_all_black = zeros((8, NodeT, length_system))
    null_w = [0] * NodeT
    all_lambda = list(np.zeros(NodeT))

    all_lambda[0] = funcs.lambda_h(jacob_matrix_sys, system_orig[0])
    for i in range(1, NodeT):
        system_orig[i] = funcs.euler_d_system(system_orig[i - 1], system_equations, 0, dt, guard_equations, reset_equations)
        lambda_i = funcs.lambda_h(jacob_matrix_sys, system_orig[i])
        # if abs(lambda_i) <= 1e-2:
        #     lambda_i = 0
        all_lambda[i] = lambda_i

    all_delta, all_gamma, wall_tube_bottom, wall_tube_top = gamma_delta_wall(system_orig, all_lambda, NodeT, length_system, system_equations, w, guard_equations, reset_equations)
    global print_check_inclusion
    global print_check_wall
    global print_check_lambda_sign
    print_check_inclusion = inclusion_check(number_periods, i_one_period, wall_tube_bottom, wall_tube_top, length_system, all_lambda, all_delta,
                    system_orig, epsilon)
    print_check_wall = min_wall_top_max_wall_bottom_check(length_system, i_one_period, wall_tube_top, wall_tube_bottom, period_inclus)
    print_check_lambda_sign = sum_lambda_sign_check(all_lambda, number_periods, i_one_period)
    display_plots(system_orig, all_lambda, all_gamma, all_delta, wall_tube_top, wall_tube_bottom, NodeT, dt,
                  tf, w, epsilon, length_system, system_equations, guard_equations, reset_equations, init_system, num_system_simu,
                  period_inclus, i_one_period, states_name, index_fig)


def display_plots(system_orig_, all_lambda_, all_gamma_, all_delta_, wall_tube_top_, wall_tube_bottom_, NodeT_, dt_, tf_, w_, ecart_epsilon_, length_system_, system_equations_, guard_equations_, reset_equations_, init_system_, num_system_simu_, i_period_inclus_, i_one_period_, states_name_, index_fig_):
    show_delta = selected_options_plot[0] == "show"
    show_color_sign_lambda = selected_options_plot[1] == "show"
    show_simulations = selected_options_plot[2] == "show"
    T = np.linspace(0, tf_, NodeT_)
    global list_plot_tabs
    list_plot_tabs = []
    global list_tabs
    list_tabs = []
    if show_simulations:
        system_simulations = system_tubes(NodeT_, length_system_, system_equations_, init_system_, num_system_simu_, guard_equations_, reset_equations_)
    else:
        system_simulations = []
    if show_color_sign_lambda:
        list_index_sys_lam_sg_change = funcs.index_sys_lambda_sign_change(system_orig_, all_lambda_)
    else:
        list_index_sys_lam_sg_change = []
    for i_states_ in range(0, length_system_):
        if selected_1d_plot[i_states_] == "show":
            tab_1d_plot_i = tkk.Frame(tabControl)
            list_tabs.append(tab_1d_plot_i)
            tabControl.add(list_tabs[-1], text=states_name_[i_states_])

            canv = plot_funcs.plot_system_t(system_orig_, i_states_, wall_tube_top_, wall_tube_bottom_, system_simulations, step_plot, states_name_, i_one_period_, i_period_inclus_, i_max_wall_bottom, i_min_wall_top, max_wall_bottom, min_wall_top,
                  dt_, tf_, w_, ecart_epsilon_, index_fig_, NodeT_, T, list_index_sys_lam_sg_change, show_sys_orig_with_lambda_sign=show_color_sign_lambda, show_simul_=show_simulations, show_wall_=show_delta, show_inter_=False, save_=True, show_fig_=True, window_tk_=list_tabs[-1])
            canvas = canv.get_tk_widget()
            canvas.grid(row=0, column=0)
            list_plot_tabs.append([states_name_[i_states_], canv])
    test_2d_plot = True
    for i_plot_2d in range(0, len(selected_2d_plot)):
        if selected_2d_plot[i_plot_2d] == "":
            test_2d_plot = False
            break
    if not selected_2d_plot:
        test_2d_plot = False
    if test_2d_plot:
        tab_2d_plot_i = tkk.Frame(tabControl)
        list_tabs.append(tab_2d_plot_i)
        tabControl.add(list_tabs[-1], text="2D plot")
        canv = plot_funcs.plot_system_2D(system_orig_, selected_2d_plot[0], selected_2d_plot[1], wall_tube_top_, wall_tube_bottom_, system_simulations, step_plot, states_name_, dt_, tf_, w_, ecart_epsilon_, index_fig_, NodeT_,
                   list_index_sys_lam_sg_change, show_sys_orig_with_lambda_sign=show_color_sign_lambda, show_simul_=show_simulations, show_wall_=show_delta, save_=True, show_fig_=True, window_tk_=list_tabs[-1])
        canvas = canv.get_tk_widget()
        canvas.grid(row=0, column=0)
        list_plot_tabs.append(["2D plot", canv])
    test_3d_plot = True
    for i_plot_3d in range(0, len(selected_3d_plot)):
        if selected_3d_plot[i_plot_3d] == "":
            test_3d_plot = False
            break
    if not selected_3d_plot:
        test_3d_plot = False
    if test_3d_plot:
        tab_3d_plot_i = tkk.Frame(tabControl)
        list_tabs.append(tab_3d_plot_i)
        tabControl.add(list_tabs[-1], text="3D plot")
        l_axe_1 = []
        l_axe_2 = []
        l_axe_3 = []
        for i_x in range(0, len(system_orig_)):
            l_axe_1.append(system_orig_[i_x][selected_3d_plot[0]])
            l_axe_2.append(system_orig_[i_x][selected_3d_plot[1]])
            l_axe_3.append(system_orig_[i_x][selected_3d_plot[2]])
        canv = plot_funcs.plot_system_3D(l_axe_1, l_axe_2, l_axe_3, selected_3d_plot[0], selected_3d_plot[1], selected_3d_plot[2], wall_tube_top_,
                   wall_tube_bottom_, system_simulations, step_plot, states_name_, dt_, tf_, w_, ecart_epsilon_, index_fig_, NodeT_, list_index_sys_lam_sg_change, show_sys_orig_with_lambda_sign=show_color_sign_lambda, show_simul_=show_simulations, show_wall_=show_delta, save_=True, show_fig_=True, window_tk_=list_tabs[-1])
        canvas = canv.get_tk_widget()
        canvas.grid(row=0, column=0)
        list_plot_tabs.append(["3D plot", canv])
    if selected_funcs_plot[0] == "show":
        tab_lambda_plot = tkk.Frame(tabControl)
        list_tabs.append(tab_lambda_plot)
        tabControl.add(list_tabs[-1], text="lambda")
        canv = plot_funcs.plot_simulation(all_lambda_, "lambda", T, step_plot, dt_, tf_, w_, ecart_epsilon_, index_fig_, save_=True, show_fig_=True, window_tk_=list_tabs[-1])
        canvas = canv.get_tk_widget()
        canvas.grid(row=0, column=0)
        list_plot_tabs.append(["lambda", canv])
    if selected_funcs_plot[1] == "show" and w > 0:
        tab_gamma_plot = tkk.Frame(tabControl)
        list_tabs.append(tab_gamma_plot)
        tabControl.add(list_tabs[-1], text="gamma")
        canv = plot_funcs.plot_simulation(all_gamma_, "gamma", T, step_plot, dt_, tf_, w_, ecart_epsilon_, index_fig_, save_=True, show_fig_=True, window_tk_=list_tabs[-1])
        canvas = canv.get_tk_widget()
        canvas.grid(row=0, column=0)
        list_plot_tabs.append(["gamma", canv])
    if selected_funcs_plot[2] == "show":
        tab_delta_plot = tkk.Frame(tabControl)
        list_tabs.append(tab_delta_plot)
        tabControl.add(list_tabs[-1], text="delta")
        canv = plot_funcs.plot_simulation(all_delta_, "delta", T, step_plot, dt_, tf_, w_, ecart_epsilon_, index_fig_, save_=True, show_fig_=True, window_tk_=list_tabs[-1])
        canvas = canv.get_tk_widget()
        canvas.grid(row=0, column=0)
        list_plot_tabs.append(["delta", canv])
    tab_result = tkk.Frame(tabControl)
    list_tabs.append(tab_result)
    lab_check_inc = tk.Label(list_tabs[-1], text=print_check_inclusion, font=("Helvtica", 12))
    lab_check_wall = tk.Label(list_tabs[-1], text=print_check_wall, font=("Helvtica", 12))
    lab_check_lambda = tk.Label(list_tabs[-1], text=print_check_lambda_sign, font=("Helvtica", 12))
    check_inclusion_label = tk.Label(list_tabs[-1], text="Check inclusion:", font=("Helvtica", 22))
    check_wall_label = tk.Label(list_tabs[-1], text="Check m_+ < M_-:", font=("Helvtica", 22))
    check_lambda_sign_label = tk.Label(list_tabs[-1], text="Check lambda sign during one period:", font=("Helvtica", 22))

    check_inclusion_label.grid(row=0, column=0, padx=5, pady=5, sticky="W")
    lab_check_inc.grid(row=1, column=0, padx=5, pady=10, sticky=tk.W)
    check_wall_label.grid(row=2, column=0, padx=5, pady=5, sticky="W")
    lab_check_wall.grid(row=3, column=0, padx=5, pady=10, sticky=tk.W)
    check_lambda_sign_label.grid(row=4, column=0, padx=5, pady=5, sticky="W")
    lab_check_lambda.grid(row=5, column=0, padx=5, pady=10, sticky=tk.W)
    tabControl.add(list_tabs[-1], text="results")


def system_tubes(NodeT_, length_system_, system_equations_, init_system_, num_system_simu_, guard_equations_, reset_equations_):
    num_system_tube = num_system_simu_
    system_tube = list(np.zeros((num_system_tube, NodeT_, length_system_)))
    limit_system_top = [x + epsilon for x in init_system_]
    limit_system_bottom = [x - epsilon for x in init_system_]
    system_tube[0][0] = limit_system_bottom
    system_tube[1][0] = limit_system_top
    init_system_tubes = []
    list_ecart_epsilon = []
    list_w_tube = []
    for i_graph in range(0, num_system_tube):
        w_i = []
        for i in range(0, NodeT_):
            w_i.append(uniform(-w, w))
        list_w_tube.append(w_i)
    for i_bios_tube in range(0, num_system_tube - 2):
        eca_rand = uniform(-epsilon, epsilon)
        init_system_tubes.append([x + eca_rand for x in init_system_])
        list_ecart_epsilon.append(eca_rand)

    for i_init_bios in range(2, num_system_tube):
        system_tube[i_init_bios][0] = init_system_tubes[i_init_bios - 2]

    for i_system_tube in range(0, num_system_tube):
        for i in range(1, NodeT_):
            system_tube[i_system_tube][i] = funcs.euler_d_system(system_tube[i_system_tube][i - 1], system_equations_,
                                                                 list_w_tube[i_system_tube][i - 1], dt, guard_equations_, reset_equations_)
            # if i == NodeT - 1:
            #     break
        print("end  tube", i_system_tube)
    return system_tube

def gamma_delta_wall(system_orig_, all_lambda_, NodeT_, length_system_, system_equations_, w_, guard_equations_, reset_equations_):
    # step_gamma = int(i_one_period / 20000) + 2
    step_gamma = 9
    saut = int(step_gamma / 3)
    step_gamma = saut * 3
    print("step_gamma=", step_gamma)
    print("saut=", saut)
    all_gamma = []
    wall_tube_top = list(np.zeros((NodeT_, length_system_)))
    wall_tube_bottom = list(np.zeros((NodeT_, length_system_)))
    all_delta = list(np.zeros(NodeT_))
    all_delta[0] = epsilon
    wall_tube_top[0] = [x + epsilon for x in system_orig_[0]]
    wall_tube_bottom[0] = [x - epsilon for x in system_orig_[0]]
    # system_gamma_bottom = zeros((NodeT_ + step_gamma, length_system))
    # system_gamma_bottom[:NodeT_] = system_tube[0, :NodeT_]
    # system_gamma_top = zeros((NodeT_ + step_gamma, length_system))
    # system_gamma_top[:NodeT_] = system_tube[1, :NodeT_]
    system_gamma_orig = list(np.zeros((NodeT_ + step_gamma, length_system_)))
    system_gamma_orig[:NodeT_] = system_orig_[:NodeT_]

    for i in range(NodeT_ - 1, NodeT_ + step_gamma):
        # system_gamma_bottom[i] = euler_d_system(system_gamma_bottom[i - 1], list_w_tube[0][i - 1], dt)
        # system_gamma_top[i] = euler_d_system(system_gamma_top[i - 1], list_w_tube[1][i - 1], dt)
        system_gamma_orig[i] = funcs.euler_d_system(system_gamma_orig[i - 1], system_equations_, 0, dt, guard_equations_, reset_equations_)
    loading = 0
    for i in range(1, NodeT_):
        if w != 0:
            comp = i - 1
            if i % int(NodeT_ / 100) == 0:
                loading += 1
                print(f'{loading}/100')
            if all_lambda_[i] < 0:
                # gamma_i_bottom = all_gamma_u(system_gamma_bottom[comp:comp + step_gamma:saut],
                #                              system_gamma_bottom[comp + saut:comp + step_gamma + saut:saut],
                #                              all_lambda_[i])
                # gamma_i_top = all_gamma_u(system_gamma_top[comp:comp + step_gamma:saut],
                #                           system_gamma_top[comp + saut:comp + step_gamma + saut:saut], all_lambda_[i])
                gamma_i_orig = funcs.all_gamma_u(system_gamma_orig[comp:comp + step_gamma:saut],
                                           system_gamma_orig[comp + saut:comp + step_gamma + saut:saut], all_lambda_[i], w_)
                # all_gamma.append(max(gamma_i_bottom, gamma_i_top, gamma_i_orig))
                # print(all_gamma[-1])
                all_gamma.append(gamma_i_orig)
            else:
                all_gamma.append(0)

            if all_gamma[i - 1] > 0:
                all_delta[i] = all_delta[i - 1] * math.exp(all_lambda_[i] * dt) + (
                        all_gamma[i - 1] * 2 * abs(w) * dt / math.sqrt(abs(all_lambda_[i])))
            else:
                all_delta[i] = all_delta[i - 1] * math.exp(all_lambda_[i] * dt)
        else:
            all_delta[i] = all_delta[i - 1] * math.exp(all_lambda_[i] * dt)

        # wall_tube_bottom[i] = system_orig_[i] - all_delta[i]
        # wall_tube_top[i] = system_orig_[i] + all_delta[i]
        wall_tube_bottom[i] = [x - all_delta[i] for x in system_orig_[i]]
        wall_tube_top[i] = [x + all_delta[i] for x in system_orig_[i]]
        # if i >= NodeT_ - 1:
        #     break
    return all_delta, all_gamma, wall_tube_bottom, wall_tube_top


def inclusion_check(periods_, i_one_period_, wall_tube_bottom_, wall_tube_top_, length_system_, all_lambda_, all_delta_, system_orig_, ecart_epsilon_):
    check_inc = "\nCheck inclusion:\n"
    inclusion_verif_index = []
    for i_periods in range(0, periods_ + 1):
        i_one_period_1 = i_one_period_
        # p1 = "Period:" + str(i_periods) + " Tube_top:" + str(wall_tube_top_[i_periods * i_one_period_1]) + " Tube_bottom:" + str(wall_tube_bottom_[i_periods * i_one_period_1])
        # print("i=", i_periods * i_one_period_1, "period:", i_periods, "tube_top:",
        #       wall_tube_top_[i_periods * i_one_period_1], " tube_bottom: ", wall_tube_bottom_[i_periods * i_one_period_1])
        p4 = "Y_0(" + str(i_periods) + "T)=" + str(system_orig_[i_periods * i_one_period_1]) + \
             ", delta_w(" + str(i_periods) + "T)=" + str(all_delta_[i_periods * i_one_period_1])
        check_inc += p4 + "\n"
        list_test_in = []
        if i_periods > 0:
            for i_len_system in range(0, length_system_):
                if wall_tube_bottom_[(i_periods - 1) * i_one_period_1][i_len_system] <= \
                        wall_tube_top_[i_periods * i_one_period_1][i_len_system] <= \
                        wall_tube_top_[(i_periods - 1) * i_one_period_1][i_len_system] and \
                        wall_tube_bottom_[(i_periods - 1) * i_one_period_1][i_len_system] <= \
                        wall_tube_bottom_[i_periods * i_one_period_1][i_len_system] <= \
                        wall_tube_top_[(i_periods - 1) * i_one_period_1][i_len_system]:
                    # p2 = str(states_name[i_len_system]) + ": period " + str(i_periods) + " in period " + str(i_periods - 1)
                    p2 = "For state " + str(states_name[i_len_system]) + ": tube at t=" + str(
                        i_periods) + "T is included in tube at t=" + str(
                        i_periods - 1) + "T"
                    check_inc += p2 + "\n"
                    # print(states_name[i_len_system], ": period ", i_periods, " in period ", i_periods - 1)
                    list_test_in.append(True)
                else:
                    list_test_in.append(False)

            if all(list_test_in):
                p3 = "For all the states: Tubes at t=" + str(i_periods) + "T are included in tubes at t=" + str(
                    i_periods - 1) + "T."
                check_inc += p3 + "\n"
                inclusion_verif_index.append(True)
                # print("all period ", i_periods, " in period ", i_periods - 1, )
            else:
                inclusion_verif_index.append(False)
        # check_inc += p4 + "\n"
        # print("i=", i_periods * i_one_period_1, "Y_0(", i_periods, "T)=", system_orig_[i_periods * i_one_period_1],
        #       "δ_w(", i_periods, "T)=", all_delta_[i_periods * i_one_period_1], "lambda*i=",
        #       all_lambda_[i_periods * i_one_period_1] * (i_periods * i_one_period_1 * dt), "epsilon*e^lambda*i=",
        #       ecart_epsilon_ * math.exp(all_lambda_[i_periods * i_one_period_1] * (i_periods * i_one_period_1 * dt)))
    compt_i_ = len(inclusion_verif_index)
    p4 = "Conclusion: "
    for i_in in reversed(inclusion_verif_index):
        if i_in:
            p4 += "B("+str(compt_i_) + "T) included in " + "B("+str(compt_i_-1) + "T)\n"
            compt_i_ -= 1
    check_inc += p4
    print(check_inc)
    return check_inc

def sum_lambda_sign_check(all_lambda_, periods_, i_one_period_):
    check_sum_lam = "\nCheck that the sum of lambda is negative for each period:\n"
    for i in range(0, periods_):
        p = "Period number " + str(i + 1) + ":" + " sum(lambda) = " + str(
            sum(all_lambda_[i * i_one_period_: (i + 1) * i_one_period_]))
        check_sum_lam += p + "\n"
        print(i + 1, "period: from", i_one_period_ * i, "->", i_one_period_ * (i + 1), "sum(lambda) = ",
              sum(all_lambda_[i * i_one_period_: (i + 1) * i_one_period_]))
    return check_sum_lam

def min_wall_top_max_wall_bottom_check(length_system_, i_one_period_, wall_tube_top_, wall_tube_bottom_, i_period_inclus_):
    global i_min_wall_top
    global i_max_wall_bottom
    global min_wall_top
    global max_wall_bottom
    i_min_wall_top = np.zeros(length_system_)
    i_max_wall_bottom = np.zeros(length_system_)
    min_wall_top = 10 * np.ones(length_system_)
    max_wall_bottom = -10 * np.ones(length_system_)

    for i_len_system in range(0, length_system_):
        for i in range(i_one_period_ * i_period_inclus_, i_one_period_ * (i_period_inclus_ + 1) + 1):
            if wall_tube_top_[i][i_len_system] < min_wall_top[i_len_system]:
                min_wall_top[i_len_system] = wall_tube_top_[i][i_len_system]
                i_min_wall_top[i_len_system] = i
            if wall_tube_bottom_[i][i_len_system] > max_wall_bottom[i_len_system]:
                max_wall_bottom[i_len_system] = wall_tube_bottom_[i][i_len_system]
                i_max_wall_bottom[i_len_system] = i

    print("i_min=", i_min_wall_top, "min_wall_top=", min_wall_top)
    print("i_max=", i_max_wall_bottom, "max_wall_bottom=", max_wall_bottom)
    # check_min_max = "i_min=" + str(i_min_wall_top) + " min_wall_top=" + str(min_wall_top)+"\n i_max=" + str(i_max_wall_bottom) + " max_wall_bottom=" + str(max_wall_bottom)
    check_min_max = "\nCheck for at least one stat that the lower limit of the top of the tube is less than the higher limit of the bottom of the tube:\n"
    # print("i_min=", i_min_wall_top, "min_wall_top=", min_wall_top)
    # print("i_max=", i_max_wall_bottom, "max_wall_bottom=", max_wall_bottom)
    checked_min_max = []
    for i_len_system in range(0, length_system_):
        check_min_max += "For the state " + states_name[
            i_len_system] + ":" + " the minimum value of the top part of the tube =" + str(
            min_wall_top[i_len_system]) + " , the maximum value of the bottom part of the tube =" + str(
            max_wall_bottom[i_len_system]) + "\n"
        if min_wall_top[i_len_system] <= max_wall_bottom[i_len_system]:
            checked_min_max.append(states_name[i_len_system])
    check_min_max += "The proposition is verified for the states: " + str(checked_min_max) + "\n"
    return check_min_max

def system_eq_symb():
    global list_syms_system
    global list_params_system
    global list_matrs_system
    list_syms_system = []
    list_syms_system_str = []
    list_params_system = []
    list_params_system_str = []
    list_matrs_system = []
    list_matrs_system_str = []
    for i_states_ in range(0, len(state)):
        list_syms_system.append(sp.Symbol(state[i_states_][0]))
        list_syms_system_str.append(state[i_states_][0])
    for i_parameters_ in range(0, len(parameter)):
        list_params_system.append(sp.Symbol(parameter[i_parameters_][0]))
        list_params_system_str.append(parameter[i_parameters_][0])
    for i_matrices_ in range(0, len(matrix)):
        list_matrs_system.append(sp.MatrixSymbol(matrix[i_matrices_][0], int(matrix[i_matrices_][5]), int(matrix[i_matrices_][6])))
        list_matrs_system_str.append(matrix[i_matrices_][0])

    list_syms_param_system = list_syms_system+list_params_system + list_matrs_system
    list_syms_param_system_str = list_syms_system_str+list_params_system_str + list_matrs_system_str
    # i = iter(list_syms_param_system)
    i = list_syms_param_system
    i_str = list_syms_param_system_str
    print("i=", i)
    print("i_str=", i_str)
    b = dict(zip(i_str, i))
    print(list_syms_param_system)
    print("b=", b)
    list_param_expres = []
    list_matr_expres = []
    list_states_expres = []
    list_guard_expres = []
    list_reset_expres = []
    for i_parameters_ in range(0, len(parameter)):
        list_param_expres.append(sp.sympify(parameter[i_parameters_][1], locals=b))
    for i_matrices_ in range(0, len(matrix)):
        list_matr_expres.append(sp.sympify(Matrix(matrix[i_matrices_][1]), locals=b))
        # for i_matrices_i in range(0, len(matrix[i_matrices_][1])):
        #     for i_matrices_j in range(0, len(matrix[i_matrices_][1][i_matrices_i])):
        #         list_matr_expres.append(sp.sympify(matrix[i_matrices_][1][i_matrices_i][i_matrices_j], locals=b))
    print(list_param_expres)
    c_ex = list_syms_system+list_param_expres + list_matr_expres
    c = dict(zip(i_str+list_params_system+list_matrs_system, c_ex+list_param_expres+list_matr_expres))
    print("c=", c)
    for i_states_ in range(0, len(state)):
        t_ = str(sp.sympify(state[i_states_][1], locals=c))
        sp_p = sp.sympify(state[i_states_][1], locals=c)
        print("out t_=", t_)
        while t_ != str(sp.sympify(t_, locals=c)):
            t_ = str(sp.sympify(t_, locals=c))
            sp_p = sp.sympify(t_, locals=c)
            print("in t_=", t_)
        # list_states_expres.append(sp.sympify(state[i_states_][1], locals=c))
        list_states_expres.append(sp_p)
        print("i_states_=", i_states_, "->", list_states_expres[i_states_])
        print("simplify_=", sp.simplify(list_states_expres[i_states_]))
    if len(guard)>0 and len(reset)>0:
        g_ = str(sp.sympify(guard[0], locals=c, evaluate=False))
        sp_g = sp.sympify(guard[0], locals=c, evaluate=False)
        print("out g_=", g_)
        print("out1 g_=", sp_g)
        while g_ != str(sp.sympify(g_, locals=c, evaluate=False)):
            g_ = str(sp.sympify(g_, locals=c, evaluate=False))
            sp_g = sp.sympify(g_, locals=c, evaluate=False)
            print("in g_=", g_)
        list_guard_expres.append(sp_g)
        print(list_guard_expres)

        for i_states_ in range(0, len(state)):
            r_ = str(sp.sympify(reset[0][i_states_], locals=c))
            sp_r = sp.sympify(reset[0][i_states_], locals=c)
            print("out r_=", r_)
            while r_ != str(sp.sympify(r_, locals=c)):
                r_ = str(sp.sympify(r_, locals=c))
                sp_r = sp.sympify(r_, locals=c)
                print("in r_=", r_)
            # list_states_expres.append(sp.sympify(state[i_states_][1], locals=c))
            list_reset_expres.append(sp_r)
            print("i_states_=", i_states_, "->", list_reset_expres[i_states_])
            print("simplify_=", sp.simplify(list_reset_expres[i_states_]))

    return list_states_expres, list_syms_system, list_guard_expres, list_reset_expres


dt = 1
w = 0
epsilon = 0
number_periods = 1
one_period_fixed = 0
step_plot = 1
selected_1d_plot = []
selected_2d_plot = []
selected_3d_plot = []
selected_funcs_plot = []
selected_options_plot = []
main_window = tk.Tk()
main_window.title("Orbitador")
main_window.geometry("900x600")

# f = BytesIO()
# sp.preview(expr_with_backslash, viewer='BytesIO', outputbuffer=f)

# sp.preview(expr, viewer='BytesIO', outputbuffer=f)
# f.seek(0)
# img = Image.open(f)
# pimg = ImageTk.PhotoImage(img)
# lbl = tk.Label(image=pimg)
# lbl.pack()
# state = [['x', 'a1+t3-3*200'], ['x2', ''], ['delta5', ''],  ['delta0', '']]
state = []
parameter = []
matrix = []
control = []
# SUB-WINDOWS
guard = []
reset = []

# FRAMES
states_frame = tk.Frame(main_window, borderwidth=1, bd=1, relief=tk.SUNKEN)
parameters_frame = tk.Frame(main_window, borderwidth=1, bd=1, relief=tk.SUNKEN)
matrices_frame = tk.Frame(main_window, borderwidth=1, bd=1, relief=tk.SUNKEN)
controls_frame = tk.Frame(main_window, borderwidth=1, bd=1, relief=tk.SUNKEN)


# LABELS
# my_label = tk.Label(main_window, text="Hello!", fg="red", bg="gray", font=("Helvtica", 32))
# state_name_label = tk.Label(main_window, text="state name", font=("Helvtica", 32))
states_list_label = tk.Label(states_frame, text="Differential equations:", font=("Helvtica", 26))
list_states_imgs = get_images_of_state_eq(state)
list_states_labels = []
list_states_name_point_imgs = get_images_of_state_name_point(state)
list_states_name_imgs, l_s = get_images_of_state_name(state)
for i_states in range(0, len(list_states_imgs)):
    list_states_labels.append(tk.Label(states_frame, image=list_states_imgs[i_states]))

parameters_list_label = tk.Label(parameters_frame, text="Parameters:", font=("Helvtica", 26))
list_parameters_imgs = get_images_of_parameter_eq(parameter)
list_parameters_name_imgs, l_p = get_images_of_parameter_name(parameter)
list_parameters_labels = []
for i_parameters in range(0, len(list_parameters_imgs)):
    list_parameters_labels.append(tk.Label(parameters_frame, image=list_parameters_imgs[i_parameters]))

matrices_list_label = tk.Label(matrices_frame, text="Matrices:", font=("Helvtica", 26))
# list_matrices_imgs = get_images_of_matrix_eq(matrix)
list_matrices_name_imgs, l_m = get_images_of_matrix_name(matrix)
list_matrices_labels = []
for i_matrices in range(0, len(list_matrices_name_imgs)):
    list_matrices_labels.append(tk.Label(matrices_frame, image=list_matrices_name_imgs[i_matrices]))


controls_list_label = tk.Label(controls_frame, text="Controls:", font=("Helvtica", 26))
# list_matrices_imgs = get_images_of_matrix_eq(matrix)
list_controls_name_imgs, l_m = get_images_of_control_name(control)
list_controls_labels = []
for i_controls in range(0, len(list_controls_name_imgs)):
    list_matrices_labels.append(tk.Label(controls_frame, image=list_controls_name_imgs[i_controls]))
    
# buttonS
edit_icon = tk.PhotoImage(file=r"edit.png")
edit_icon = edit_icon.subsample(20)

delete_icon = tk.PhotoImage(file=r"delete.png")
delete_icon = delete_icon.subsample(5)
new_state_button = tk.Button(states_frame, text="Add new state", command=open_new_state_window)
new_guard_reset_button = tk.Button(states_frame, text="Add a guard and a reset", command=open_guard_reset_window)
list_states_edit_button = []
for i_states in range(0, len(list_states_imgs)):
    print("i_states=", i_states)
    list_states_edit_button.append(tk.Button(states_frame, text='Edit', image=edit_icon, compound=tk.LEFT, command=lambda i_states1=i_states: open_edit_state_window(i_states1)))

new_parameter_button = tk.Button(parameters_frame, text="Add new parameter", command=open_new_parameter_window)
list_parameters_edit_button = []
for i_parameters in range(0, len(list_parameters_imgs)):
    print("i_parameters=", i_parameters)
    list_parameters_edit_button.append(tk.Button(parameters_frame, text='Edit', image=edit_icon, compound=tk.LEFT, command=lambda i_parameters1=i_parameters: open_edit_parameter_window(i_parameters1)))

new_matrix_button = tk.Button(matrices_frame, text="Add new matrix", command=open_new_matrix_window)
list_matrices_edit_button = []
for i_matrices in range(0, len(list_matrices_name_imgs)):
    print("i_matrices=", i_matrices)
    list_matrices_edit_button.append(tk.Button(matrices_frame, text='Edit', image=edit_icon, compound=tk.LEFT, command=lambda i_matrices1=i_matrices: open_edit_matrix_window(i_matrices1)))
    
new_control_button = tk.Button(controls_frame, text="Add new control", command=open_new_control_window)
list_controls_edit_button = []
for i_controls in range(0, len(list_controls_name_imgs)):
    print("i_controls=", i_controls)
    list_controls_edit_button.append(tk.Button(controls_frame, text='Edit', image=edit_icon, compound=tk.LEFT, command=lambda i_controls1=i_controls: open_edit_control_window(i_controls1)))
# ENTRIES


# DEFINE MENUS
main_window_menu = tk.Menu(main_window)
main_window.config(menu=main_window_menu)

# CREATE MENU ITEMS
file_menu = tk.Menu(main_window_menu, tearoff=0)
states_menu = tk.Menu(main_window_menu, tearoff=0)
parameters_menu = tk.Menu(main_window_menu, tearoff=0)
matrices_menu = tk.Menu(main_window_menu, tearoff=0)
controls_menu = tk.Menu(main_window_menu, tearoff=0)
setting_menu = tk.Menu(main_window_menu, tearoff=0)
run_menu = tk.Menu(main_window_menu, tearoff=0)

# main_window_menu.add_cascade(label="File", menu=file_menu)
main_window_menu.add_cascade(label="States", menu=states_menu)
main_window_menu.add_cascade(label="Parameters", menu=parameters_menu)
main_window_menu.add_cascade(label="Matrices", menu=matrices_menu)
# main_window_menu.add_cascade(label="Controls", menu=controls_menu)
main_window_menu.add_cascade(label="Setting", menu=setting_menu)
main_window_menu.add_cascade(label="Run", menu=run_menu)

# CREATE SUBMENU
file_menu.add_command(label="New", command=new_file)
file_menu.add_command(label="Open", command=open_file)
file_menu.add_separator()
file_menu.add_command(label="Save", command=save_file)
file_menu.add_command(label="Save As", command=save_as_file)
file_menu.add_separator()
file_menu.add_command(label="Exit", command=exit_file)

states_menu.add_command(label="New", command=open_new_state_window)
states_menu.add_command(label="Edit name", command=edit_state_name)
states_menu.add_command(label="Delete", command=delete_state)

parameters_menu.add_command(label="New", command=open_new_parameter_window)
parameters_menu.add_command(label="Edit name", command=edit_parameter_name)
parameters_menu.add_command(label="Delete", command=delete_parameter)

matrices_menu.add_command(label="New", command=open_new_matrix_window)
matrices_menu.add_command(label="Edit name", command=edit_matrix_name)
matrices_menu.add_command(label="Delete", command=delete_matrix)

controls_menu.add_command(label="New", command=open_new_control_window)
controls_menu.add_command(label="Edit name", command=edit_control_name)
controls_menu.add_command(label="Delete", command=delete_control)
controls_menu.add_command(label="Config", command=config_control)

setting_menu.add_command(label="Configuration", command=open_configuration_window)
setting_menu.add_command(label="Display", command=open_display_setting_window)

run_menu.add_command(label="Run", command=open_run_window)


# DISPLAY WIDGETS
# my_label.pack()
states_list_label.grid(row=0, column=0)
for i_states in range(0, len(list_states_labels)):
    list_states_labels[i_states].grid(row=i_states+1, column=0, sticky="W", pady=10)
    list_states_edit_button[i_states].grid(row=i_states+1, column=1, sticky="W", padx=30, pady=10)
new_state_button.grid(row=len(list_states_labels)+1, column=0, pady=10)
new_guard_reset_button.grid(row=len(list_states_labels)+2, column=0, pady=10)
states_frame.grid_columnconfigure(0, minsize=350)

parameters_list_label.grid(row=0, column=0, padx=20)
for i_parameters in range(0, len(list_parameters_labels)):
    list_parameters_labels[i_parameters].grid(row=i_parameters+1, column=0, sticky="W", pady=10)
    list_parameters_edit_button[i_parameters].grid(row=i_parameters+1, column=1, sticky="W", padx=30, pady=10)
new_parameter_button.grid(row=len(list_parameters_labels)+1, column=0, pady=1)

matrices_list_label.grid(row=0, column=0, padx=20)
for i_matrices in range(0, len(list_matrices_labels)):
    list_matrices_labels[i_matrices].grid(row=i_matrices+1, column=0, sticky="W", pady=10)
    list_matrices_edit_button[i_matrices].grid(row=i_matrices+1, column=1, sticky="W", padx=30, pady=10)
new_matrix_button.grid(row=len(list_matrices_labels)+1, column=0, pady=30)

controls_list_label.grid(row=0, column=0, padx=20)
for i_controls in range(0, len(list_controls_labels)):
    list_controls_labels[i_controls].grid(row=i_controls+1, column=0, sticky="W", pady=10)
    list_controls_edit_button[i_controls].grid(row=i_controls+1, column=1, sticky="W", padx=30, pady=10)
new_control_button.grid(row=len(list_controls_labels)+1, column=0, pady=30)


states_frame.grid(row=0, column=0, padx=20, pady=20, sticky="W")
parameters_frame.grid(row=0, column=1, padx=20, pady=20, sticky="N")
matrices_frame.grid(row=1, column=1, padx=20, pady=20, sticky="N")
# controls_frame.grid(row=1, column=0, padx=20, pady=20, sticky="N")
main_window.grid_columnconfigure(0, minsize=500)
main_window.grid_columnconfigure(1, minsize=100)

# state_name_label.pack()
# states_list_labela.pack()
# state_name_entry.pack()
# b1.pack()

main_window.mainloop()
