import matplotlib.pyplot as plot1
import matplotlib.pyplot as plot4
import matplotlib.pyplot as plot3D
import numpy as np
from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg


def plot_system_t(sys_orig_, index_state_, wall_top_, wall_bottom_, tubes_, step_plot_, states_name_, i_one_period_, i_period_inclus_, i_max_wall_bottom_, i_min_wall_top_, max_wall_bottom_, min_wall_top_,
                  dt_, tf_, w_, ecart_epsilon_, index_fig_, NodeT_, T_, list_index_sys_lambda_sig, show_sys_orig_with_lambda_sign, show_simul_, show_wall_, show_inter_,
                  save_, show_fig_, window_tk_):
    fig1 = plot1.figure()
    ax1 = plot1.gca()
    plot1.xlabel('t')
    plot1.ylabel(states_name_[index_state_])
    if show_simul_:
        for i_system_tube in range(0, len(tubes_)):
            plot1.plot(T_[:NodeT_:step_plot_], np.array(tubes_)[i_system_tube, :NodeT_:step_plot_, index_state_], color='blue')
    if show_wall_:
        plot1.plot(T_[:NodeT_ - 1:step_plot_], np.array(wall_top_)[:NodeT_ - 1:step_plot_, index_state_], color='green')
        plot1.plot(T_[:NodeT_ - 1:step_plot_], np.array(wall_bottom_)[:NodeT_ - 1:step_plot_, index_state_],
                   color='green')
    if show_sys_orig_with_lambda_sign:
        if list_index_sys_lambda_sig[1]:
            first_color = 'red'
            second_color = 'green'
        else:
            first_color = 'green'
            second_color = 'red'
        for i_cut in range(1, len(list_index_sys_lambda_sig[0])):
            if i_cut % 2 == 1:
                plot1.plot(T_[list_index_sys_lambda_sig[0][i_cut-1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_], np.array(sys_orig_)[list_index_sys_lambda_sig[0][i_cut-1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_, index_state_], color=first_color)
            else:
                plot1.plot(T_[list_index_sys_lambda_sig[0][i_cut-1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_], np.array(sys_orig_)[list_index_sys_lambda_sig[0][i_cut-1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_, index_state_], color=second_color)
    else:
        plot1.plot(T_[:NodeT_:step_plot_], np.array(sys_orig_)[:NodeT_:step_plot_, index_state_], color='red')

    if show_inter_:
        min_wall_tube_bottom_ = min(np.array(wall_bottom_)[:NodeT_ - 1:step_plot_, index_state_])
        max_wall_tube_top_ = max(np.array(wall_top_)[:NodeT_ - 1:step_plot_, index_state_])
        dis_wall_bottom_top = abs(max_wall_tube_top_ - min_wall_tube_bottom_)
        min_wall_tube_bottom_ -= dis_wall_bottom_top * 0.05
        max_wall_tube_top_ += dis_wall_bottom_top * 0.05
        plot1.plot([T_[i_one_period_ * i_period_inclus_], T_[i_one_period_ * i_period_inclus_]],
                   [min_wall_tube_bottom_, max_wall_tube_top_], color='black')
        plot1.plot([T_[i_one_period_ * (i_period_inclus_ + 1)], T_[i_one_period_ * (i_period_inclus_ + 1)]],
                   [min_wall_tube_bottom_, max_wall_tube_top_], color='black')
        plot1.plot(T_[int(i_max_wall_bottom_[index_state_])], max_wall_bottom_[index_state_], 'o', color='gray')
        plot1.plot(T_[int(i_min_wall_top_[index_state_])], min_wall_top_[index_state_], 'o', color='cyan')
    if save_:
        plot1.savefig(
            f'system-{states_name_[index_state_]}-dt=1-on-{round(1 / dt_, 2)}-tf={round(tf_, 2)}-w={w_}-epsilon={ecart_epsilon_}-{index_fig_}.png')
    if show_fig_:
        plot1.show()
    canvas_ = FigureCanvasTkAgg(fig1, master=window_tk_)
    plot1.clf()
    return canvas_


def plot_system_2D(sys_orig_, index_state_1_, index_state_2_, wall_top_, wall_bottom_, tubes_, step_plot_, states_name_, dt_, tf_, w_, ecart_epsilon_, index_fig_, NodeT_,
                   list_index_sys_lambda_sig, show_sys_orig_with_lambda_sign, show_simul_, show_wall_, save_, show_fig_, window_tk_):
    fig1 = plot1.figure()
    ax1 = plot1.gca()
    plot1.xlabel(states_name_[index_state_1_])
    plot1.ylabel(states_name_[index_state_2_])
    if show_simul_:
        for i_system_tube in range(0, len(tubes_)):
            plot1.plot(np.array(tubes_)[i_system_tube, :NodeT_:step_plot_, index_state_1_],
                       np.array(tubes_)[i_system_tube, :NodeT_:step_plot_, index_state_2_], color='blue')
    if show_wall_:
        plot1.plot(np.array(wall_top_)[:NodeT_ - 1:step_plot_, index_state_1_],
                   np.array(wall_top_)[:NodeT_ - 1:step_plot_, index_state_2_], color='green')
        plot1.plot(np.array(wall_bottom_)[:NodeT_ - 1:step_plot_, index_state_1_],
                   np.array(wall_bottom_)[:NodeT_ - 1:step_plot_, index_state_2_], color='green')

    if show_sys_orig_with_lambda_sign:
        if list_index_sys_lambda_sig[1]:
            first_color = 'red'
            second_color = 'green'
        else:
            first_color = 'green'
            second_color = 'red'
        for i_cut in range(1, len(list_index_sys_lambda_sig[0])):
            if i_cut % 2 == 1:
                plot1.plot(np.array(sys_orig_)[list_index_sys_lambda_sig[0][i_cut-1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_, index_state_1_], np.array(sys_orig_)[list_index_sys_lambda_sig[0][i_cut-1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_, index_state_1_], color=first_color)
            else:
                plot1.plot(np.array(sys_orig_)[list_index_sys_lambda_sig[0][i_cut-1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_, index_state_1_], np.array(sys_orig_)[list_index_sys_lambda_sig[0][i_cut-1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_, index_state_2_], color=second_color)
    else:
        plot1.plot(np.array(sys_orig_)[:NodeT_:step_plot_, index_state_1_], np.array(sys_orig_)[:NodeT_:step_plot_, index_state_2_], color='red')

    if save_:
        plot1.savefig(
            f'system-{states_name_[index_state_1_]}-{states_name_[index_state_2_]}-dt=1-on-{round(1 / dt_, 2)}-tf={round(tf_, 2)}-w={w_}-epsilon={ecart_epsilon_}-{index_fig_}.png')
    if show_fig_:
        plot1.show()
    canvas_ = FigureCanvasTkAgg(fig1, master=window_tk_)
    plot1.clf()
    return canvas_


def plot_system_3D(sys_orig_1, sys_orig_2, sys_orig_3, index_state_1_, index_state_2_, index_state_3_, wall_top_,
                   wall_bottom_, tubes_, step_plot_, states_name_, dt_, tf_, w_, ecart_epsilon_, index_fig_, NodeT_, list_index_sys_lambda_sig, show_sys_orig_with_lambda_sign, show_simul_, show_wall_, save_, show_fig_, window_tk_):
    fig1 = plot3D.figure()
    ax = plot3D.axes(projection='3d')
    # ax.set_xlabel(states_name[index_state_1_])
    # ax.set_ylabel(states_name[index_state_2_])
    # ax.set_zlabel(states_name[index_state_3_])

    ax.set_xlabel(r'x')
    ax.set_ylabel(r'y')
    ax.set_zlabel(r'z')
    if show_simul_:
        for i_system_tube in range(0, len(tubes_)):
            ax.plot3D(np.array(tubes_)[i_system_tube, :NodeT_:step_plot_, index_state_1_],
                      np.array(tubes_)[i_system_tube, :NodeT_:step_plot_, index_state_2_],
                      np.array(tubes_)[i_system_tube, :NodeT_:step_plot_, index_state_3_], color='blue')
    if show_wall_:
        ax.plot3D(np.array(wall_top_)[:NodeT_ - 1:step_plot_, index_state_1_],
                  np.array(wall_top_)[:NodeT_ - 1:step_plot_, index_state_2_],
                  np.array(wall_top_)[:NodeT_ - 1:step_plot_, index_state_3_], color='green')
        ax.plot3D(np.array(wall_bottom_)[:NodeT_ - 1:step_plot_, index_state_1_],
                  np.array(wall_bottom_)[:NodeT_ - 1:step_plot_, index_state_2_],
                  np.array(wall_bottom_)[:NodeT_ - 1:step_plot_, index_state_3_], color='green')
    # print("sys_orig_1=", sys_orig_1)
    if show_sys_orig_with_lambda_sign:
        if list_index_sys_lambda_sig[1]:
            first_color = 'red'
            second_color = 'green'
        else:
            first_color = 'green'
            second_color = 'red'
        for i_cut in range(1, len(list_index_sys_lambda_sig[0])):
            if i_cut % 2 == 1:
                ax.plot3D(np.array(sys_orig_1)[list_index_sys_lambda_sig[0][i_cut-1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_],
                          np.array(sys_orig_2)[list_index_sys_lambda_sig[0][i_cut-1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_],
                          np.array(sys_orig_3)[list_index_sys_lambda_sig[0][i_cut-1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_],
                          color=first_color)
            else:
                ax.plot3D(np.array(sys_orig_1)[list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_],
                          np.array(sys_orig_2)[list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_],
                          np.array(sys_orig_3)[list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_],
                          color=second_color)
    else:
        ax.plot3D(np.array(sys_orig_1)[:NodeT_:step_plot_], np.array(sys_orig_2)[:NodeT_:step_plot_], np.array(sys_orig_3)[:NodeT_:step_plot_], color='red')
    ax.plot3D(np.array(sys_orig_1)[0], np.array(sys_orig_2)[0], np.array(sys_orig_3)[0], 'o', color='black')
    # ax.set_xlim3d(-1.1, 1.1)
    # ax.set_ylim3d(-1.1, 1.1)
    # ax.set_zlim3d(-0.2, 0.2)
    if save_:
        plot3D.savefig(f'system-3D-{states_name_[index_state_1_]}-{states_name_[index_state_2_]}-{states_name_[index_state_3_]}-dt=1-on-{round(1 / dt_, 2)}-tf={round(tf_, 2)}-w={w_}-epsilon={ecart_epsilon_}-{index_fig_}.png')
    if show_fig_:
        plot3D.show()
    canvas_ = FigureCanvasTkAgg(fig1, master=window_tk_)
    plot3D.clf()
    return canvas_


def plot_simulation(simul_, simul_name_, T_, step_plot_, dt_, tf_, w_, ecart_epsilon_, index_fig_, save_, show_fig_, window_tk_):
    fig4 = plot4.figure()
    ax4 = plot4.gca()
    plot4.xlabel('t')
    plot4.ylabel(simul_name_)
    len_simul_ = len(simul_)
    plot4.plot(T_[:len_simul_:step_plot_], simul_[:len_simul_:step_plot_], color='red')
    if save_:
        plot4.savefig(f'system-{simul_name_}-dt=1-on-{round(1 / dt_, 2)}-tf={round(tf_, 2)}-w={w_}-epsilon={ecart_epsilon_}-{index_fig_}.png')
    if show_fig_:
        plot4.show()
    canvas_ = FigureCanvasTkAgg(fig4, master=window_tk_)
    plot4.clf()
    return canvas_

